<?php
ob_start();

class dbgrid {

    private $link;

    private $table;

    private $caption;

    private $dbgrid_action;

    private $name_upload;

    private $old_name_upload;

    private $condition = ' WHERE 1=1 ';

    private $join     = '';

    private $language ='en';

    private $groupby  = '';

    private $search   = '';

    private $htmlentities_for_field = array();

    private $per_page = 20;

    private $page     = 1;

    private $fields   = '*';

    private $fields_edit   = '*';

    private $orderby  = '';

    private $sortdir  = '';

    private $salt               = 'superSecret';

    private $user_directory     = './uploads/';

    private $pagination_anchors = '';

    private $pagination_total   = '';

    private $pk                 = '';

    private $foreignpk          = '';

    private $res_request          = array();

    private $colwidths            = array();

    private $structure            = array();

    private $force_import_field   = array();

    private $field_name           = array();

    private $field_hide           = array();

    private $field_search         = array();

    private $field_no_edit        = array();

    private $field_edit_condition = array();

    private $edit_type_on_condition = array();

    private $validation_callbacks = array();

    private $validation_type      = array();

    private $delete_callbacks     = array();

    private $insert_callbacks     = array();

    private $update_callbacks     = array();

    private $custom_toolbar       = array();

    private $notice               = array();

    private $error                = array();

    // Add Several Joins to do multiple level associations/relations
    private $joins                = array();

    private $foreign              = array();

    private $custom_edit_form     = "";

    private $edit_custom_function = "";

    private $debug        = true;

    private $stopnow      = false;

    private $nocheckbox   = false;

    private $modify_pk    = false;

    private $allow_view   = true;

    private $allow_add    = true;

    private $allow_delete = true;

    private $allow_sync   = false;

    private $allow_edit   = true;

    private $allow_export = true;

    private $allow_import = true;

    private $allow_search = false;

    private $edit_in_place = false;

    private $custom_action_button = array();

    /**
     * Constructor
     *
     * @param string $link
     * @return void
     */
    public function __construct($link) {
        $this->link    = $link;
        $this->get_request();
        return;
    }

    /**
     * Destructor
     *
     * @return void
     */
    public function __destruct() {
        // nada
        return false;
    }

    private function get_request() {

        $get_post = array_merge($_GET,$_POST);

/*
        echo "<pre>";
        print_r($_GET);
        print_r($get_post);
        print_r($_POST);
        print_r($_REQUEST);
        echo "</pre>";
*/

        $cancel = '';
        $ok     = '';

        foreach($get_post as $key=>$val) {
            $val=htmlspecialchars($val);
            if(substr($key,0,4)=="amp;") {
               $key=substr($key,4);
            }
            if($key=='dbgrid_page') {
                $this->page = intval($val);
            } elseif($key=='per_page') {
                $this->per_page = intval($val);
            } elseif($key=='dbgrid_sort') {
                $this->orderby=$val;
            } elseif($key=='dbgrid_sortdir') {
                $this->sortdir=$val;
            } elseif($key=='dbgrid_action'){
                $this->dbgrid_action=$val;
            } elseif($key=='dbgrid_notice'){
                $this->notice[]=$val;
            } elseif($key=='dbgrid_error'){
                $this->error[]=$val;
            } elseif($key=='dbgrid_search'){
                $this->search=urlencode($val);
                $this->res_request[$key] = urlencode($val);
            }
            if($key<>"button_ok" && $key <>"button_cancel" &&
               $key<>"dbgrid_notice" && $key<>"dbgrid_error" && !preg_match("/_insert_/",$key)) {
                $this->res_request[$key] = $val;
            }
            if($key=="button_cancel") {
                $cancel=$val;
            }
            if($key=="button_ok") {
                $ok=$val;
            }
        }
        if($cancel<>"" || $ok<>"" ) {
            if($cancel<>"") {
                $req = $this->set_request("dbgrid_action","list",true);
                $this->dbgrid_action="list";
            }
            // Si cancelamos algun form, hay que borar todos los campos de la tabla
            $table = ($cancel<>"")?$cancel:$this->table;
            $this->set_table($table);

            foreach ($this->res_request as $field){
                if($ok<>"" && $field == $this->pk) {
                } else {
                    if(!is_array($field)) {
                         unset($this->res_request[$field]);
                    }
                }
            }
            foreach ($this->structure as $field => $value){
                if(array_key_exists($field,$this->res_request)) {
                    if($ok<>"" && $field == $this->pk) {
                       // no borramos el id del request
                    } else {
                        unset($this->res_request[$field]);
                    }
                }
            }
        }

    }

    private function del_request($param) {
        unset($this->res_request[$param]);
        $ret = array();
        $return = "";
        foreach($this->res_request as $key=>$val) {
            $ret[]="$key=$val";
        }
        $return = implode("&",$ret);
        if($return<>"") {
            $return ="?".$return;
        }
        return $return;
    }

    public function set_edit_custom_function($custom_function) {
        $this->edit_custom_function=$custom_function;
    }

    public function set_custom_edit_form($custom_edit_form) {
        $this->custom_edit_form=$custom_edit_form;
    }

    public function set_custom_action_button($custom_action_button) {
        array_push($this->custom_action_button,$custom_action_button);
    }

    public function set_edit_type_on_condition($typearray) {
        if(!is_array($typearray)) {
            $this->edit_type_on_condition = Array();
        }
        $this->edit_type_on_condition=$typearray;
    }

    public function set_autocomplete_suggestions($field,$suggestions) {
        if(!is_array($suggestions)) {
            $suggestions = preg_split("/,/",$suggestions);
        }
        $this->structure[$field]['autocomplete'] = $suggestions;
    }

    public function set_language($language='en') {
        $this->language=$language;
    }

    public function set_nocheckbox($val=true) {
        $this->nocheckbox=$val;
    }

    private function set_request($param, $value, $store=true) {
        if ($param === 'dbgrid_page') {
            $this->res_request['dbgrid_action'] = 'list';
        }

        $ret = array();

        if($store) {
            $this->res_request[$param]=$value;
        }

        $return = "";
        $estaba=0;

        foreach($this->res_request as $key=>$val) {
            if((!$store) && $param == $key) {
                $estaba=1;
                $ret[]="$param=$value";
            } else {
                $ret[]="$key=$val";
            }
        }

        if($estaba==0) {
            if(!array_key_exists($param,$this->res_request)) {
                $ret[]="$param=$value";
            }
        }
        // quiero que el dbbrid_search este siempre ultimo por caracteres especiales #
        $ret2=array();
        $salvame="";
        foreach($ret as $valor) {
            if(preg_match("/^dbgrid_search/",$valor)) {
                $salvame=$valor;
            } else {
                $ret2[]=$valor;
            }
        }
        if($salvame<>"") { $ret2[] = $salvame; }

        $ret3 = array();
        foreach($ret2 as $val) {
            if(preg_match("/^dbgrid_/",$val) || preg_match("/^$this->pk=/",$val)) {
                $ret3[] = $val;
            }
        }

        $return = implode("&",$ret3);

        if($return<>"") {
            $return ="?".$return;
        }

        return $return;
    }

    //Permite habilitar la modificacion de PK
    private function change_pk($modify){
        $this->modify_pk=$modify;
    }

    public function set_pk($field){
        $this->pk=$field;
    }

    //Permite setear un directorio para administrar archivos
    public function set_user_directory($directory){
        $this->user_directory=$directory;
    }

    //Permite habilitar el boton agregar
    public function allow_add($allow_add){
        $this->allow_add=$allow_add;
    }

    //Permite habilitar el boton ver
    public function allow_view($allow_view){
        $this->allow_view=$allow_view;
    }


    //Permite habilitar el boton borrar
    public function allow_delete($allow_delete){
        $this->allow_delete=$allow_delete;
        if($allow_delete == false) {
            $this->nocheckbox=1;
        }
    }

    //Permite habilitar el boton editar
    public function allow_edit($allow_edit){
        $this->allow_edit=$allow_edit;
    }

    //Permite habilitar el boton exportar
    public function allow_export($allow_export){
        $this->allow_export=$allow_export;
    }

    //Permite habilitar el boton importar
    public function allow_import($allow_import){
        $this->allow_import=$allow_import;
    }

    //Buscar
    public function allow_search($allow_search){
       $this->allow_search=$allow_search;
    }

    public function edit_in_place($eip){
       $this->edit_in_place=$eip;
    }

    public function salt($salt){
        $this->salt=$salt;
    }

    private function table_row($datos, $extraclass, $key, $rawdata, $contid) {

        $colnumber=1;

        if($extraclass<>'') {
            $extraclass=" class='$extraclass'";
        }

        $ret = "<tr $extraclass id='datarow_$contid'>\n";

        $countcontrol=0;

        if ($this->allow_edit) {
            $countcontrol++;
        }
        if ($this->allow_view) {
            $countcontrol++;
        }
        if ($this->allow_delete) {
            $countcontrol++;
        }



        $this->del_request("dbgrid_action");
        $this->del_request($this->pk);

        if(is_array($datos)) {

            $this->apply_display_filters($datos,$rawdata);

            foreach($datos as $campo=>$valor) {

                $eip_class='edit';
                $dataSelect = "";

                if(isset($this->structure[$campo])) {

                if ($this->structure[$campo]['input'] == 'textarea') {
                     // textarea, select, multiselect para edit in place
                     $eip_class='edit_area';
                } else if( $this->structure[$campo]['input'] == 'select' || $this->structure[$campo]['input'] == 'multiselect' ) {
                     $eip_class='edit_select';

                    if(!is_array($this->structure[$campo]['values'])) {
                        $this->structure[$campo]['values'] = Array();
                    }
                    $optionsSelect = Array();
                    foreach ($this->structure[$campo]['values'] as $k => $v) {
                        $vprint = $this->get_edit_filtered($campo,$v);
                        $optionsSelect[] = $vprint.":".$k;
                    }
                    $dataSelect = "data-select='".implode(",",$optionsSelect)."'";

                } else {
                     $eip_class='edit';
                }

                if (empty($this->structure[$campo]['display_filter'])) {
                    $valor = $this->clean_entities($valor);
                }
                }


                $columnStyle=isset($this->structure[$campo]['columnstyle'])?$this->structure[$campo]['columnstyle']:'';
                if($valor=='') { $valor='&nbsp;'; }
                $ret.="<td style='";
                if($this->dbgrid_action!='pdf') {
                     $ret.="text-overflow:ellipsis; white-space: nowrap; overflow:hidden; ";
                }
                $ret.="$columnStyle'>";
                if($this->edit_in_place) {
                    $ret.="<div rel='tooltip' class='".$eip_class."' $dataSelect style='margin:0;width:96%;' id='eip!${key}!${campo}'>";
                }
                $ret.=$valor;
                if($this->edit_in_place) {
                    $ret.="</div>";
                }
                $ret.="</td>\n";
                $colnumber++;
            }

        } else {
            $datos = $this->clean_entities($datos);
            $ret.="<td>\n";
            if($this->edit_in_place) {
                $ret.="<div rel='tooltip' class='".$eip_class."'  style='margin:0;width:96%;'id='eip!${key}!${campo}'>";
            }
            $ret.=$datos;
            if($this->edit_in_place) {
                $ret.="</div>";
            }
            $ret.="</td>\n";
            $colnumber++;
        }

        if($this->dbgrid_action!='pdf' && $countcontrol>0) {

            // No queremos acciones si exportamos a pdf

            $ret.= "<td>";
            $ret.= "<div class='btn-group'>";

            $req=$this->set_request($this->pk,$key,true);
            $req = preg_replace("/\&/","&amp;",$req);

            if($this->allow_view) {
                $req=$this->set_request('dbgrid_action','show',true);
                $req = preg_replace("/\&/","&amp;",$req);
                $ret.="<button class='btn db-table-btn' rel='tooltip' onClick='window.location=\"".SELF."$req\"' title='".trans('View Record')."' ><img class='eye-icon' src='images/new/Eye-vector.svg'/></button>"; // <i class='glyphicon glyphicon-eye-open'></i>
            }

            if($this->allow_edit) {
                $cureq=$this->set_request('dbgrid_action','edit',true);
                $cureq = preg_replace("/\&/","&amp;",$cureq);
                if($this->edit_custom_function<>'') {
                    $mifunc = $this->edit_custom_function."(\"$cureq\")";
                    $ret.="<button class='btn db-table-btn' rel='tooltip' onClick='$mifunc' title='".trans('Edit Record')."'><img class='eye-icon' src='images/new/Pencil-vector.svg'/></button>";//<i class='glyphicon glyphicon-edit'></i>
                } else {
                    $ret.="<button class='btn db-table-btn' rel='tooltip' onClick='window.location=\"".SELF."$cureq\"' title='".trans('Edit Record')."'><img class='eye-icon' src='images/new/Pencil-vector.svg'/></button>";// before <i class='glyphicon glyphicon-edit'></i>
                }
            }

            if($this->allow_delete) {
                $req=$this->set_request('dbgrid_action','delete',true);
                $req=$this->set_request('dbgrid_pkhash',md5($this->salt.$key),false);
                $req = preg_replace("/\&/","&amp;",$req);
                $ret.="<button class='btn jconf db-table-btn' style='z-index:0' rel='tooltip' id=\"".SELF."$req\" title='".trans('Delete')."'><img class='eye-icon' src='images/new/Trash-vector.svg'/></button>";// before <i class='glyphicon glyphicon-trash'></i>
            }

            if(count($this->custom_action_button)>0) {
                foreach($this->custom_action_button as $boton) {
                    $ret.=$boton;
                }
            }
            $ret.="</div>";
            $ret.="</td>\n";
        }

        if($this->nocheckbox != 1) {
            if($this->dbgrid_action!='pdf') {
                $ret.="<td style='overflow:hidden; width:20px;'><input type=checkbox onclick='clearCheckAll(this)' id='dbgrid_checkbox_".$key."' /></td>\n";
                $colnumber++;
            }
        }

        $ret .= "\n</tr>\n";
        if($this->dbgrid_action!='pdf') {
            $ret .= "<tr id='datarow_${contid}_drill' style='display:none;'><td id='datarow_${contid}_drill_td' colspan='$colnumber'></td></tr>\n";
        }
        return $ret;
    }


    private function table_head($datos,$orden=array()) {

        $ret = "<tr>\n";

        $countcontrol=0;
        if ($this->allow_edit) {
            $countcontrol++;
        }
        if ($this->allow_view) {
            $countcontrol++;
        }
        if ($this->allow_delete) {
            $countcontrol++;
        }

        $colnum=0;

        foreach($this->colwidths as $width) {
            $width = str_replace('%', '', (string)$width);
            $ancho[$colnum] = $width === "*" ? '30px' : "{$width}px";
            $colnum++;
        }

        if(is_array($datos)) {

            $cont=0;

            foreach($datos as $valor) {

                //$valor = $this->clean_entities($valor);
                if(!isset($orden[$cont])) { $orden[$cont]=''; }

                $req_uri = $this->set_request("dbgrid_sort",$orden[$cont],true);

                $newdir="";
                $custom_sort_dir="";

                if($orden[$cont]==$this->orderby) {

                    $custom_sort_dir = $_REQUEST['dbgrid_sortdir'];

                    if($custom_sort_dir == "") {
                        $newdir = "ASC";
                    } else if($custom_sort_dir == "DESC") {
                        $newdir = "";
                        $req_uri = $this->del_request("dbgrid_sort",false);
                        $req_uri = $this->del_request("dbgrid_sortdir",false);
                    } else {
                        $newdir = "DESC";
                    }

                    $req_uri = $this->set_request("dbgrid_sortdir",$newdir,false);
                    $arrow = ($custom_sort_dir == "ASC")?"glyphicon glyphicon-arrow-up":"glyphicon glyphicon-arrow-down";
                    $add_arrow="<i class='$arrow'></i>";
                } else {
                    $req_uri = $this->set_request("dbgrid_sortdir","ASC",false);
                    $add_arrow="";
                }

                $ret.="<th style='text-align: left; ";
                if($this->dbgrid_action=='pdf') {
                    $ret.=" width:".$ancho[$cont].";";
                }
                $ret.="'>";
                if($this->dbgrid_action!='pdf') {
                    $req_uri = preg_replace("/\&/","&amp;",$req_uri);
                    $ret.="<a href='".SELF."$req_uri'>";
                }
                $ret.=$valor;

                if($this->dbgrid_action!='pdf') {
                    $ret.="</a><div style='float:right;'>$add_arrow</div>";
                }
                $ret.="</th>\n";
                $cont++;
            }
            if(isset($_REQUEST['dbgrid_sort'])) {
                $req_uri = $this->set_request("dbgrid_sort",$_REQUEST['dbgrid_sort'],true);
            } else {
                $req_uri = $this->del_request("dbgrid_sort",true);
            }
            if(isset($_REQUEST['dbgrid_sortdir'])) {
                $req_uri = $this->set_request("dbgrid_sortdir",$_REQUEST['dbgrid_sortdir'],true);
            }
        } else {
            //$datos = $this->clean_entities($datos);
            $ret.="<th><a href='".SELF."'>$datos</a></th>\n";
        }

        if($this->dbgrid_action!='pdf' && $countcontrol>0) {
            // No queremos accion ni checkbox si exportamos a pdf
            $ret.="<th>&nbsp;</th>\n";
            if($this->nocheckbox != 1) {
                $ret.="<th class='tcheck'><input type=checkbox id='checkall' onclick='checkAll(this,\"maintable_".$this->table."\")' /></th>\n";
            }
        }

        $ret .= "\n</tr>\n\n";
        return $ret;
    }


    public function set_table($table) {

        if($this->table) { return; }
        if(!$table) { return; }
        $this->table = $table;

        //Tipos de datos en mysql
        $basetypes = 'real|double|float|decimal|numeric|tinyint|smallint|mediumint|int|bigint|date|time|timestamp|datetime|char|varchar|tinytext|text|mediumtext|longtext|enum|set|tinyblob|blob|mediumblob|longblob';
        $extra     = 'unsigned|zerofill|binary|ascii|unicode| ';

        $this->link->consulta("SET NAMES 'UTF8'");
        $res = $this->link->consulta("DESC $table");

        if(!$res) {
            $this->add_error($this->link>escape_string($this->link->error()));
            $this->stopnow = true;
            $this->print_grid();
            die();
        }

        while($row = $this->link->fetch_assoc($res)) {

            preg_match("#^($basetypes)(\([^)]+\))?($extra)*$#i", $row['Type'], $matches);
                // Tipo de dato?
            switch ($matches[1]) {
                case 'smalltext':
                case 'mediumtext':
                case 'text':
                case 'longtext':
                    $this->add_structure($row['Field'], 'textarea');
                    break;
                case 'enum':
                    $type   = substr($row['Type'], 6, -2);
                    $values = array_flip(preg_split("#','#", $type));
                    foreach ($values as $k => $v) {
                        $values[$k] = $k;
                    }
                    $this->add_structure($row['Field'], 'select', $values,$row['Default']);
                    break;
                case 'date':
                    $this->add_structure($row['Field'], 'date', null, date('Y-m-d'));
                    break;
                case 'time':
                    $this->add_structure($row['Field'], 'time', null, date('H:i:s'));
                    break;
                case 'datetime':
                    $this->add_structure($row['Field'], 'datetime', null, date('Y-m-d H:i:s'));
                    break;
                default:
                    $this->add_structure($row['Field'], 'text',null,$row['Default']);
            }
            //$this->structure[$row['Field']]=$row;
            if ($row['Key'] == 'PRI'){
                $this->pk = $row['Field'];
            }
        }
    }

    public function force_import_field($field,$value){
        $this->force_import_field[$field] = $value;
    }

    public function add_structure($name, $inputType, $values = null, $default = null, $instructions = null, $foreigntable = null, $foreignkey = null, $union = null){
        $this->structure[$name] = array ('display'        => $name,
                                         'input'          => $inputType,
                                         'values'         => $values,
                                         'display_filter' => array(),
                                         'edit_filter'    => array(),
                                         'instructions'   => $instructions,
                                         'foreigntable'   => $foreigntable,
                                         'foreignkey'     => $foreignkey,
                                         'union'          => $union,
                                         'default'        => $default);
    }

    public function set_caption($caption) {
        $this->caption = $caption;
    }

    public function set_orderby($orderby) {
        if(!$this->orderby) {
            $this->orderby = $orderby;
        }
    }

    public function set_orderdirection($orderby) {
        if(!$this->sortdir) {
            $this->sortdir = $orderby;
        }
    }

    public function add_join_table($foreigntable,$foreignfield,$mainpk,$foreignName='',$fields='', $union='') {
        $this->joins[] = "LEFT JOIN $foreigntable ON $foreignfield=$mainpk";
        $this->foreign[$foreigntable]['foreignfield'] = $foreignfield;
        $this->foreign[$foreigntable]['mainpk']       = $mainpk;
        $this->foreign[$foreigntable]['name']         = $foreignName;
        $this->foreign[$foreigntable]['fields']       = $fields;
        $this->foreign[$foreigntable]['union']        = $union;

        if(preg_match("/ /",$foreigntable)) {
            // this is for striping a potential alias "left join table as t1"
            list($onlyName,$nada) = preg_split("/ /",$foreigntable);
        } else {
            $onlyName = $foreigntable;
        }
        $res = $this->link->consulta("DESC $onlyName");
        while($row = $this->link->fetch_assoc($res)) {
            if ($row['Key'] == 'PRI'){
                $this->foreign[$foreigntable]['pk'] = $row['Field'];
                //$this->foreign[$foreigntable]['pk'] = $foreigntable.".".$row['Field'];
            }
        }
    }

    public function set_groupby($groupby) {
        $this->groupby = $groupby;
    }

    public function set_condition($condition) {
        $this->condition = "WHERE ".$condition." ";
    }

    public function set_search($search) {
        $this->search = urlencode($search);
    }

    public function set_column_widths($widths) {
        $this->colwidths = $widths;
    }

    public function set_column_style($campo,$style) {
        if(array_key_exists($campo,$this->structure)) {
            $this->structure[$campo]['columnstyle']=$style;
        }
    }

    public function set_input_style($campo,$style) {
        if(array_key_exists($campo,$this->structure)) {
            $this->structure[$campo]['style']=$style;
        }
    }

    public function set_input_parent_style($campo,$style) {
        if(array_key_exists($campo,$this->structure)) {
            $this->structure[$campo]['parentstyle']=$style;
        }
    }

    public function set_field_explode($campo) {
        if(array_key_exists($campo,$this->structure)) {
            $this->structure[$campo]['explode']=1;
        } else {
           print_r($this->structure);
        }
    }

    public function set_field_instructions($campo,$instructions) {
        if(array_key_exists($campo,$this->structure)) {
            $this->structure[$campo]['instructions']=$instructions;
        } else {
           print_r($this->structure);
        }
    }

    public function set_input_type($campo,$tipo,$valores='') {
        if(array_key_exists($campo,$this->structure)) {
            $this->structure[$campo]['input']=$tipo;
            if(isset($valores)) {
                $this->structure[$campo]['values']=$valores;
            }
        }
    }

    public function set_fields($fields) {
        $this->fields = $fields;
    }

    public function set_fields_edit($fields) {
        $this->fields_edit = $fields;
    }

    public function set_per_page($perpage) {
        $this->per_page = $perpage;
    }

    private function clean_entities($param) {
        return is_array($param) ? array_map('clean_entities', $param) : html_entity_decode($param, ENT_QUOTES);
    }

    private function construct_count_query() {
        $query = "SELECT count(*) FROM ".$this->table." ";
        if(count($this->joins)>0) {
            foreach($this->joins as $idx=>$jointable) {
               $query .= $jointable." ";
            }
        }
        if($this->condition <> "") {
            $query .= " ".$this->condition;
        }
        if($this->search <> "") {
            $query_parts=array();

            foreach ($this->field_search as $key=>$val ){
                $qstring = preg_replace("/\%/","\\%%",addslashes(urldecode($this->search)));
                $query_parts[]= "$key LIKE '%%".$qstring."%%'";
            }
            if(count($query_parts) > 0) {
                $searchquery=implode(" OR ",$query_parts);
                $query .= " AND ( ".$searchquery.") ";
            }

        }
        if($this->groupby <> "") {
           $query .= " ".$this->groupby;
        }
        return $query;
    }


    private function construct_query($limit=true,$group=true) {

        $vars   = Array();
        $return = Array();

        if($this->stopnow) {
            $return[] = "";
            $return[] = $vars;
            return $return;
        }

        $query = "SELECT ".$this->fields." FROM ".$this->table." ";

        if(count($this->joins)>0) {
            foreach($this->joins as $idx=>$jointable) {
               $query .= $jointable." ";
            }
        }

        if($this->condition <> "") {
           $query .= $this->condition;
        }

        if($this->search <> "") {
            $query_parts=array();
            foreach ($this->field_search as $key=>$val ){
                $qstring = preg_replace("/%/","\\%%",addslashes(urldecode($this->search)));
                $query_parts[]= "$key LIKE '%%".$qstring."%%'";
            }
            if(count($query_parts) > 0) {
                $searchquery=implode(" OR ",$query_parts);
                $query .= " AND (".$searchquery.") ";
            }
        }

        if($group) {
            if($this->groupby <> "") {
                $query .= $this->groupby;
            }
        }

        if(array_key_exists('dbgrid_sort',$this->res_request)) {
               $query .= " ORDER BY %s %s ";
               $vars[]=$this->orderby;
               $vars[]=$this->sortdir;
        } else {
            if($this->orderby <> "") {
                $query .= " ORDER BY %s %s ";
                $vars[]=$this->orderby;
                $vars[]=$this->sortdir;
            }
        }
        if($limit) {
            $start_record = ($this->page * $this->per_page) - $this->per_page ;
            $query .= " LIMIT %s,%s ";
            $vars[]=$start_record;
            $vars[]=$this->per_page;
        }

        $return[] = $query;
        $return[] = $vars;
        return $return;
    }

    private function set_pagination() {

        $query   = $this->construct_count_query();
        $rst     = $this->link->consulta($query);

        if($this->groupby == "") {
            list($numrows) = $this->link->fetch_row($rst);
        } else {
            $numrows = $this->link->num_rows($rst);
        }
        $anc     = '';

        $next  = $this->page+1;
        $var   = ((intval($numrows/$this->per_page))-1)*$this->per_page;
        $last  = ceil($numrows/$this->per_page);

        $previous = $this->page-1;

        $anc = "<div class='pagination pagination-centered sp-pagination'><ul>";

        if($previous <= 0){
            $anc .= "<li class='disabled'><a title='".trans('First')."'>&laquo;</a></li><li class='disabled'><a title='".trans('Previous')."'>&lsaquo;</a></li>";
        }else{
            $req_uri = $this->set_request('dbgrid_page',1,false);
            $anc .= "<li><a href='".SELF."$req_uri' title='".trans('First')."'>&laquo;</a></li>\n";
            $req_uri = $this->set_request('dbgrid_page',$previous,false);
            $anc .= "<li><a href='".SELF."$req_uri' title='".trans('Previous')."'>&lsaquo;</li></a>";
        }

        $norepeat = 4; // numero de paginas a mostrar a izq y der
        $anch     = "";
        $j = 1;

        $break=0;
        for($i=$this->page; $i>1; $i--){
            $page = $i-1;
            $req_uri = $this->set_request('dbgrid_page',$page,false);
            $anch = "<li><a href='".SELF."$req_uri'>$page</a></li>".$anch;
            if($j == $norepeat) { $break=1; break; };
            $j++;
        }
        $anc .= $anch;

        $antes = $norepeat + 1 - $j;

        if($break==0) {
            $norepeat+=$antes;
        }

        $anc .= "<li class='active'><a>".$this->page."</a></li>\n";

        $j = 1;

        for($i=$this->page; $i<$last; $i++){
            $page = $i+1;
            $req_uri = $this->set_request('dbgrid_page',$page,false);
            $anc .= "<li><a href='".SELF."$req_uri'>$page</a></li>\n";
            if($j==$norepeat) break;
            $j++;
        }

        if($this->page >= $last){
            $anc .= "<li class='disabled'><a title='".trans('Next')."'>&rsaquo;</a></li><li class='disabled'><a title='".trans('Last')."'>&raquo;</a></li>\n";
        }else{
            $req_uri = $this->set_request('dbgrid_page',$next,false);
            $anc .= "<li><a href='".SELF."$req_uri' title='".trans('Next')."'>&rsaquo;</a></li>";

            $req_uri = $this->set_request('dbgrid_page',$last,false);
            $anc .= "<li><a href='".SELF."$req_uri' title='".trans('Last')."'>&raquo;</a></li>";
        }
        $anc.="</ul></div>\n";

        $this->pagination_anchors = $anc;

        $this->pagination_total = "<div style='text-align:center;' class='gray' >".trans('Page')." : $this->page <i> ".trans('of')."  </i> $last . ".trans('Total records found').": <span id='numrows_".$this->table."'>$numrows</span></div>";
    }

    public function hide_field($field) {
        if(is_array($field)) {
           foreach($field as $campo) {
               $this->field_hide[$campo]=1;
           }
        } else {
            $this->field_hide[$field]=1;
        }
    }

    public function set_default_values($fields,$values) {
        $cont=0;
        if(is_array($fields)) {
           foreach($fields as $campo) {
               if(array_key_exists($campo,$this->structure)) {
                   $this->structure[$campo]['default']=$values[$cont];
               }
               $cont++;
           }
        } else {
            if(array_key_exists($fields,$this->structure)) {
                $this->structure[$fields]['default']=$values;
            }
        }
    }

    public function no_edit_field($field){
        if(is_array($field)) {
           foreach($field as $campo) {
               $this->field_no_edit[$campo]=1;
           }
        } else {
            $this->field_no_edit[$field]=1;
        }
    }

    public function edit_field_condition($field,$conditionfield,$cond,$value) {
            $this->field_edit_condition[$field]="$conditionfield|$cond|$value";
    }

    public function set_display_name($field,$newname) {
        if(is_array($field)) {
           $cont=0;
           foreach($field as $campo) {
               $this->field_name[$campo]=$newname[$cont];
               $cont++;
           }
        } else {
            $this->field_name[$field]=$newname;
        }
    }

    public function set_htmlentities_for_field($field) {
        if(is_array($fields)) {
            foreach($fields as $campo) {
                $this->htmlentities_for_field[$field]=1;
            }
        } else {
            $this->htmlentities_for_field[$field]=1;
        }
     }


       //Buscar
    public function set_search_fields($fields) {
        if(is_array($fields)) {
            foreach($fields as $campo) {
                $this->field_search[$campo]=1;
            }
        } else {
            $this->field_search[$fields]=1;
        }
     }

    public function add_error($error) {
        $this->error[]=$error;
    }
    public function add_notice($error) {
        $this->notice[]=$error;
    }

    public function add_custom_toolbar($texto) {
         $this->custom_toolbar[] = $texto;
    }
   /**
    * Adds an delete callback. Gets called when a row is deleted. All
    * row data is passed as an array to the callback function.
    *
    * @param callback $callback The callback to be used
    */
    public function add_delete_callback($callback) {
       if (is_callable($callback)) {
           $this->delete_callbacks[] = $callback;
       } else {
           $this->error[] = trans("Fallo al agregar delete callback - callback no valido");
       }
    }

    public function add_insert_callback($callback) {
       if (is_callable($callback)) {
           $this->insert_callbacks[] = $callback;
       } else {
           $this->error[] = trans("Fallo al agregar insert callback - callback no valido");
       }
    }

    public function add_update_callback($callback) {
       if (is_callable($callback)) {
           $this->update_callbacks[] = $callback;
       } else {
           $this->error[] = trans("Fallo al agregar update callback - callback no valido");
       }
    }

    public function add_validation_callback($field, $callback) {
        if (!is_callable($callback)) {
           $this->error[] = trans("Fallo al agregar validation callback - callback no valido");
        } else {
            if (!empty($this->structure[$field]) AND empty($this->field_no_edit[$field])) {
                $this->validation_callbacks[$field][] = $callback;
            }
        }
    }

    public function add_validation_type($field, $type) {
        // Tipos validos:
        // required
        // alfanumeric
        // text
        // numeric
        // email
        // url
        if (!empty($this->structure[$field]) AND empty($this->field_no_edit[$field])) {
            $this->validation_type[$field][] = $type;
        }
    }

    public function add_display_filter($field, $callback) {

        if (is_callable($callback) AND isset($this->structure[$field])) {
            $this->structure[$field]['display_filter'][] = $callback;

        } else if (is_callable($callback)) {
            $this->error[] = trans("Unknown field: %s", $field);

        } else {
            $this->error[] = trans("Fallo al agregar display filter - callback no valido");
        }
    }

    /**
    * Applys display filters to a single row of data. Does htmlspecialchars() first.
    *
    * @param array &$results Data from table
     */
    private function apply_display_filters(&$raw,&$row) {
        foreach ($row as $field => $value) {
            if (!empty($this->structure[$field]['display_filter'])) {
                foreach ($this->structure[$field]['display_filter'] as $f) {
                    $value = call_user_func($f, $value, $row);
                }
                $raw[$field] = $value;
            }
        }
    }

    public function add_edit_filter($field, $callback) {

        if (is_callable($callback) AND isset($this->structure[$field])) {

            $this->structure[$field]['edit_filter'][] = $callback;

        } else if (is_callable($callback)) {

            $this->error[] = trans("Unknown field: %s", $field);

        } else {

            $this->error[] = trans("Fallo al agregar edit filter - callback no valido");

        }
    }

    private function get_edit_filtered($field,$value) {
        if (!empty($this->structure[$field]['edit_filter'])) {
            foreach ($this->structure[$field]['edit_filter'] as $f) {
                $value = call_user_func($f, $value);
            }
        }
        return $value;
    }

    private function check_validation_type($field,$value) {
        foreach ($this->validation_type[$field] as $type) {
            $fieldname = isset($this->field_name[$field])?$this->field_name[$field]:$field;
            switch($type) {
                case 'required':
                    if(is_array($value)) {
                        if(count($value)==0) {
                            $this->add_error(trans('Field %s is required',$fieldname));
                        }
                    } else {
                        if(strlen($value)==0) {
                            $this->add_error(trans('Field %s is required',$fieldname));
                        }
                    }
                    break;
                case 'alfanumeric':
                    if(!$this->isAlfaNumeric($value)) {
                        $this->add_error(trans('Field %s can only contain alfanumeric characters',$fieldname));
                    }
                    break;
                case 'text':
                    if(!$this->isAlfa($value)) {
                        $this->add_error(trans("El campo %s solo puede contener letras", $fieldname));
                    }
                    break;
                case 'numeric':
                    if(!is_numeric($value)) {
                        $this->add_error(trans("El campo %s debe ser numerico", $fieldname));
                    }
                    break;
                case 'email':
                    if(!$this->isEmail($value)) {
                        $this->add_error(trans("El campo %s no es un email valido", $fieldname));
                    }
                    break;
                case 'url':
                    if(!$this->isURL($value)) {
                        $this->add_error(trans("El campo %s no es un url valido", $fieldname));
                    }
                    break;
            }
        }
    }

    private function edit_in_place_action($post) {
        @ob_clean();
        $datos = print_r($post,1);
        list($nothing,$id,$field) = preg_split("/!/",$post['element_id']);

        if(!isset($this->htmlentities_for_field[$field])) {
            $this->htmlentities_for_field[$field]=0;
        }

        if($this->htmlentities_for_field[$field]==1) {
            $post['update_value']=htmlentities(utf8_decode($post['update_value']));
        } else {
            $post['update_value']=urldecode($post['update_value']);
        }

        $this->link->consulta( "UPDATE %s SET %s='%s' WHERE %s='%s'",$this->table,$field,$post['update_value'],$this->pk,$id );

        if( $this->structure[$field]['input'] == 'select' || $this->structure[$field]['input'] == 'multiselect' ) {

            if(!is_array($this->structure[$field]['values'])) {
                $this->structure[$field]['values'] = Array();
            }
            $optionsSelect = Array();
            foreach ($this->structure[$field]['values'] as $k => $v) {
                $vprint = $this->get_edit_filtered($field,$v);
                $optionsSelect[$k] = $vprint;
            }
            echo urldecode($optionsSelect[$post['update_value']]);
            die();

        }
        echo urldecode($post['update_value']);
        die();
    }

    public function show_grid() {
        switch($this->dbgrid_action) {
            case 'eip':
                $this->edit_in_place_action($_POST);
                break;
            case 'csv':
                if(isset($_REQUEST['dbgrid_search'])) {
                    $this->search=urlencode($_REQUEST['dbgrid_search']);
                }
                $this->export_csv();
                break;
            case 'pdf':
                if(isset($_REQUEST['dbgrid_search'])) {
                    $this->search=urlencode($_REQUEST['dbgrid_search']);
                }
                $this->export_pdf();
                break;
            case 'import':
                $this->import_csv();
                break;
            case 'delete_marked':
                $this->delete_marked();
                break;
            case 'foreignDelete':
                $this->ajax_foreign_delete();
                break;
            case 'list':
                $this->print_grid();
                break;
            case 'edit':
                if(array_key_exists($this->pk,$this->res_request)) {
                    $this->edit_form($this->res_request[$this->pk]);
                }
                break;
            case 'editSave':
                if(array_key_exists($this->pk,$this->res_request)) {
                    $this->update_row($this->res_request[$this->pk]);
                }
                break;
            case 'show':
                if(array_key_exists($this->pk,$this->res_request)) {
                    $this->show_form($this->res_request[$this->pk]);
                } else {
                    print_r($_REQUEST);
                }
                break;
            case 'delete':
                if(array_key_exists($this->pk,$this->res_request)) {
                    $this->delete_rows(array($this->res_request[$this->pk]));
                }
                break;
            case 'add':
                $this->add_form();
                break;
            case 'addSave':
                $this->insert_row();
                break;
            case 'search':
                $this->search_rows();
                break;
            case 'sync':
                $this->sync();
                break;
            default:
                $this->print_grid();
        }
    }

    private function print_toolbar() {

        $buttons= "
        <table class='table db-table-up'>
        ";

        // CAPTION
        if($this->caption <> "") {
            $buttons.= "<caption class='db-table-title'><h3>".$this->caption."</h3></caption>\n";
        }


        $buttons.="
            <tbody>
                <tr>
                    <td><div style='float:left;'>";

        if ($this->allow_add) {
            $req=$this->set_request('dbgrid_action','add',true);
            $buttons.= "
            <a href='#' class='btn db-up-btn add' onclick='javascript:location=\"".SELF.$req."\"'><i class='glyphicon glyphicon-plus'></i> ".trans('Add')."</a>";//btn-default
        }

        if ($this->allow_delete) {
            $req=$this->set_request('dbgrid_action','delete_marked',false);

            $buttons.="
                        <a class='btn db-up-btn remove' disabled='disabled' id='erasemarked'><i class='glyphicon glyphicon-trash glyphicon glyphicon-white'></i> ".trans('Delete Marked')."</a>";//btn-danger

        }

        if ($this->allow_sync) {
            $this->set_request('dbgrid_action','sync',false);
            $buttons.= "
            <a href='#' class='btn db-up-btn sync' id='sync'><i class='glyphicon glyphicon-refresh'></i> ".trans('Sync')."</a>";
        }

        $buttons.="</div> ";
        if ($this->allow_export) {
            $req=$this->set_request('dbgrid_action','csv',false);
            $buttons.="<div class='btn-group pull-left' style='margin-left:4px;'>
                    <a class='btn dropdown-toggle db-up-btn' data-toggle='dropdown'><i class='fa fa-upload'></i> ".trans('Export')." <span class='caret'></span></a>
                    <ul class='dropdown-menu'>
                       <li><a onclick='javascript:location=\"".SELF.$req."\"' >CSV</a></li>";
            $req=$this->set_request('dbgrid_action','pdf',false);
            $buttons.="
                       <li><a onclick='javascript:location=\"".SELF.$req."\"' >PDF</a></li>
                    </ul></div>
            ";//btn btn-default dropdown-toggle db-up-btn

        }

        if ($this->allow_import) {
            $req=$this->set_request('dbgrid_import','',false);
            $params = explode("&",$req);
            $buttons.="<div class='btn-group pull-left' style='margin-left:4px;'>
                    <a class='btn dropdown-toggle db-up-btn' data-toggle='dropdown'><i class='glyphicon glyphicon-download-alt'></i> ".trans('Import')." <span class='caret'></span></a>
                    <ul class='dropdown-menu'><li>
                         <form method='post' id='dbgrid_importmyfile' action='".SELF."' enctype='multipart/form-data' class='well form-inline form-horizontal nomargin'>
                         <input type='hidden' name='dbgrid_action' value='import' />
                         <input type='file' name='dbgrid_import' onChange='document.forms.dbgrid_importmyfile.submit();'/>
                         </form>
                    </ul>
                   </div>
            ";////btn-default
        }

        // Custom toolbar
        foreach($this->custom_toolbar as $texto) {
           $buttons.=$texto;
        }

        if ($this->allow_search) {
            $req=$this->set_request('dbgrid_action','search',true);
            $req=$this->del_request('dbgrid_search');
            $req=$this->set_request('dbgrid_page',1,false);
            $params = explode("&",$req);
            $buttons.="
                         <form method='post' action='".SELF.$req."' class='form-search' style='float:right;'>
                         <div class='btn-group'><input type='text' id='dbgrid_search' name='dbgrid_search' class='form-control input-medium search-query' style='padding-right:20px;' value='".urldecode($this->search)."' />";
            $buttons.="<span id='dbgrid_search_x' class='glyphicon glyphicon-remove-circle'></span></div>";

                    $buttons.="<input type='reset' onclick='return false;' id='dbgrid_search_x' style='height:18px; width:20px; border:none; cursor:pointer; background-color:transparent;position:relative;margin-left:-20px;background-image: url( images/glyphicons-halflings.png );background-position: -312px 0; box-shadow:none; -webkit-box-shadow:none;-moz-box-shadow:none; margin-top:2px; display:none; opacity:.5;' value=''>";

                       foreach($params as $v) {
                       list($key,$val)=preg_split("/=/",$v);
                       if ($key=='dbgrid_sortdir' || $key=='dbgrid_sort'){
                          $buttons.="<input type=hidden name='$key' value='$val'>\n";
                       }
                       }
            $buttons.="
                 <button type='submit' class='btn db-query-submit'><i class='glyphicon glyphicon-search'></i> ".trans('Search')."</button>
                  </form>
            ";
        }

        $buttons.="
                </td>
                </tr>
            </tbody>
            </table>";
            $this->del_request("dbgrid_action");
            $this->set_request("dbgrid_search",$this->search,true);
            echo $buttons;

                echo "<div id='markAllWarning' style='display:none;'></div>";
        }

    public function setAllowSync(bool $value) {
        $this->allow_sync = $value;
    }

    private function sync(){
        $this->print_javascript();
    }

        private function import_csv(){

            $valid_field = Array();

            foreach ($this->structure as $field => $value){
                if(trim($field)<>"id") {
                   $valid_field[]=trim($field);
                }
            }

            $arrFile = $_FILES['dbgrid_import'];
            $file = $arrFile['tmp_name'];

            if ($arrFile['size']>0 && !empty($file)) {
                if (is_uploaded_file($file)) {
                    if (copy ($file, $this->user_directory."importCSV-".$arrFile['name'])) {
                        $this->name_upload="importCSV-".$arrFile['name'];
                    }else{
                        $this->add_error(trans('Could not copy uploaded file'));
                    }
                }else{
                    $this->add_error(trans('Could not upload file'));
                }
            }else{
                $this->add_error(trans('Could not upload file'));
            }

            if($this->name_upload == "") {
                $this->add_error(trans('Empty file?'));
            } else {

                $mifilename = $this->user_directory.$this->name_upload;
                $csv = new parseCSV();
                $csv->auto($mifilename);
                $import_values = Array();
                $forced_values = Array();
                $valid_fields  = 0;

                foreach ($csv->titles as $key ) {
                    if(in_array(trim($key),$valid_field)) {
                        if(!array_key_exists($key,$this->force_import_field)) {
                            $import_values[$key]='';
                            $valid_fields++;
                        } else {
                            $this->add_error(trans('Ignoring field ').$key);
                        }
                    }
                }

                if($valid_fields==0) {
                    $this->add_error(trans('No valid fields to import!'));
                    $this->print_grid();
                    die();
                }

                foreach ($this->force_import_field as $key=>$val) {
                    $forced_values[$key]=$this->link->escape_string($val);
                }

                $cuantos = 0;
                foreach ($csv->data as $key => $row) {
                    foreach($row as $rkey=>$rval) {
                        if(array_key_exists($rkey,$import_values)) {
                            $import_values[$rkey]=$rval;
                        }
                    }
                    $import_final = array_merge($import_values,$forced_values);
                    $queryfields = implode(",",array_keys($import_final));
                    $queryvalues = implode("','",array_values(array_map(array($this->link,'escape_string'),$import_final)));
                    $query = "INSERT INTO $this->table ($queryfields) VALUES ('$queryvalues')";
                    $resinsert = $this->link->consulta($query);
                    if($this->link->affected_rows()>0) {
                        $cuantos++;
                    }
                }
                $this->add_notice($cuantos." ".trans('Records imported'));
            }
            $this->print_grid();
        }

        private function delete_marked(){
            $myids = $this->res_request["dbgrid_delete_id"];
            $this->del_request("dbgrid_action");
            $this->del_request("dbgrid_delete_id");
            if($myids <> "") {
                if($myids == "wholeSelection") {
                    $this->delete_rows('todos','marked');
                } else {
                    $ids_a_borrar = explode(",",$myids);
                    $this->delete_rows($ids_a_borrar,'marked');
                }
            } else {
                $this->print_grid();
            }
        }

        private function ajax_foreign_delete(){
            $id_to_delete = $_POST['foreignId'];
            $tableForeign = $_POST['foreignTable'];

                if(md5($this->salt.$id_to_delete) <> $_POST['dbgrid_pkhash']) {
                   die('Trampa con el formulario');
                } else {

            $query = "DELETE FROM %s WHERE %s='%s'";
                    $params = array($tableForeign, $this->foreign[$tableForeign]['pk'], $id_to_delete);
                    $this->link->consulta($query,$params);

                    if($this->link->affected_rows()>0) {
                //header("HTTP/1.0 404 Not Found");
                    } else {
                header("HTTP/1.0 404 Not Found");
                    }
                    die();
            }
        }

        private function export_pdf() {

        list ($query,$vars) = $this->construct_query(false);

        $res = $this->link->consulta($query,$vars);
        if($this->link->num_rows($res)==0) {
            $this->add_error(trans('There are no records to export'));
            $this->print_grid();
            return;
        }
        @ob_clean();

        // HEADING
        // recupera los nombres de los campos y los guarda en un array
        $headings = $this->link->field_name_array();

        $headings_final  = array();
        $orden           = array();

        $cont=0;
        foreach($headings as $h) {
            $cont++;
            if(array_key_exists($h,$this->field_hide)) {
            // Salteamos los campos hide
            continue;
            }
            $orden[] = $cont;
            if(array_key_exists($h,$this->field_name)) {
            $headings_final[] = $this->field_name[$h];
            } else {
            $headings_final[] = $h;
            }
        }

                echo "<html><head>";
                echo "
<!-- EXAMPLE OF CSS STYLE -->
<style>
th {
background-color: #def;
}
tr {
background-color: #fff;
}
tr.odd {
background-color: #f6f6f6;
}

   table.first {
        color: #003300;
        font-family: helvetica;
        font-size: 10pt;
        background-color: #ffffff;
        width: 100%;
    }
</style>";
                echo "</head> ";
                echo "<body style='width:560px; padding:0;'>\n";

        echo "<table class='first' cellpadding='5' cellspacing='2' border=0>\n";

        if($this->link->num_rows($res)>0) {
            echo "\n<thead>";
            echo  $this->table_head($headings_final);
            echo "</thead>\n";
        }
        echo "<tbody>\n";
                $cont=1;
        if ($this->link->num_rows($res) > 0) {

            while ($r = $this->link->fetch_assoc($res)) {
            // oculta los campos hide
            if(is_callable("array_diff_key")) {
                $j = array_diff_key($r,$this->field_hide);
            } else {
                $j = PHP4_array_diff_key($r,$this->field_hide);
            }
            $class = $cont%2?'even':'odd';
            echo $this->table_row($j,$class,$r[$this->pk],$r,$cont);
                        $cont++;
            }

        }
        echo "</tbody>\n";
        echo "</table>\n";
                echo "</body>\n</html>";

                //@ob_flush();
                //die();

                // DOMPDF
                require_once(dirname(__FILE__)."/dompdf/dompdf_config.inc.php");
                //$tmpdir = dirname($_SERVER['SCRIPT_FILENAME'])."/dompdf/tmp";
                $dompdf = new DOMPDF();
                $dompdf->set_paper('A4','landscape');
                $dompdf->load_html(utf8_decode(ob_get_contents()));
                $dompdf->render();
                @ob_end_clean();

                $report_name = urldecode($this->table).".pdf";

                $dompdf->stream($report_name);

                die();
            }

        private function Unaccent($string) {
            return preg_replace('~&([a-z]{1,2})(acute|cedil|circ|grave|lig|orn|ring|slash|th|tilde|uml);~i', '$1', htmlentities($string, ENT_QUOTES, 'UTF-8'));
        }

        private function export_csv() {

            global $CONFIG;

            if(isset($CONFIG['csv_delimiter'])) {
                $delimiter = $CONFIG['csv_delimiter'][''];
            } else {
                $delimiter=",";
            }

            list ($query,$vars) = $this->construct_query(false);

            $resq = $this->link->consulta($query,$vars);
            if($this->link->num_rows($resq)==0) {
                $this->add_error(trans('There are no records to export'));
                $this->print_grid();
                return;
            }
            @ob_end_clean();

            $filename = $this->table.".csv";
            /*
            header('Content-Type: text/csv');
            header("Content-Disposition: attachment; filename=$filename");
            $cont=1;
            while ($row = $this->link->fetch_assoc()) {
                if($cont==1) {
                $columnas = Array();
                foreach($row as $columna=>$valor) {
                    $columnas[] = $columna;
                }
                $header = implode($delimiter,$columnas);
                    echo "$header\n";
                }
                $milinea = Array();
                foreach($row as $columna=>$valor) {
                    $milinea[] = $valor;
                }
                $linea = implode($delimiter,$milinea);
                echo "$linea\n";
                $cont++;
            }
            */
            $final = Array();

            $row = $this->link->fetch_assoc($resq);
            $titles = array_keys($row);
            db_seek($resq,0);

            while ($row = $this->link->fetch_assoc($resq)) {
               $final[] = $row;
            }
            $csv = new parseCSV();
            $csv->data = $final;
            $csv->output ($filename, $final, $titles, $delimiter);
            die();
        }

        private function print_grid() {

            // construye la consulta en base a modificadores, etc.
            list ($query,$vars) = $this->construct_query();
            $this->print_javascript();

            if($this->link->error()) {
                $this->print_errors();
                return;
            }

            // realiza la consulta
            $res = $this->link->consulta($query,$vars);

            // comienza a imprimir la tabla
            $this->print_errors();

            echo "<input type='hidden' id='dbgrid_selectAll' name='dbgrid_selectAll' value='0'>\n";
            echo "<div class='container-fluid db-table-block'>\n";
            echo "<div class='row-fluid db-table-row_'>\n";

            // HEADING
            // recupera los nombres de los campos y los guarda en un array
            $headings = $this->link->field_name_array($res);

            $headings_final  = array();
            $orden           = array();

            $cont=0;
            foreach($headings as $h) {
                $cont++;
                if(array_key_exists($h,$this->field_hide)) {
                    // Salteamos los campos hide
                    continue;
                }
                $orden[] = $cont;
                if(array_key_exists($h,$this->field_name)) {
                    $headings_final[] = $this->field_name[$h];
                } else {
                    $headings_final[] = $h;
                }
            }

            echo "<div class='span12'>";
            $this->print_toolbar();
            echo "</div>\n</div>\n\n";

            echo "<div class='row-fluid db-table-row_'>\n";
            echo "<div class='span12'>\n";
            echo "<table class='table table-bordered' id='maintable_".$this->table."' style='table-layout:fixed;'>\n";

            $colspan      = 0;
            $countcontrol = 0;

            if ($this->allow_edit) {
                $countcontrol++;
            }
            if ($this->allow_view) {
                $countcontrol++;
            }
            if ($this->allow_delete) {
                $countcontrol++;
            }
            $cuantos = count($this->custom_action_button);
            if($cuantos>0) { $countcontrol += $cuantos; }

            $count=1;
            foreach($this->colwidths as $width) {
                if($count>count($headings_final)) {
                     // Si hay col width de mas, ignoramos
                     continue;
                }
                $units = strpos((string)$width, '%') ? '' : 'px';
                $colStyle = ($width <> '*') ? "style='width:{$width}{$units};'" : '';
                echo "<col $colStyle />";

                $colspan++;
                $count++;
            }

            if($countcontrol>0) {
                $controlwidth = round($countcontrol * 3.5);
                echo "<col style='width:${controlwidth}%;'/>";
                $colspan++;
            }

            if($this->nocheckbox != 1) {
                echo "<col style='width:36px;'/>";
                $colspan++;
            }


            // Completo col para todas las columnas si no se especificaron anchos
            $coldif = count($headings_final) - count($this->colwidths);
            for($a=1;$a<=$coldif;$a++) {
                $colspan++;
                $style = $a === $coldif ? 'style="width:44px;"' : '';
                echo "<col " . $style . " />";
            }

            if($this->link->num_rows($res)>0) {
                echo "<thead>";
                echo  $this->table_head($headings_final,$orden);
                echo "</thead>";
            }
            echo "<tbody>\n";

            $cont=0;

            if ($this->link->num_rows($res) > 0) {

                while ($r = $this->link->fetch_assoc($res)) {
                // oculta los campos hide
                    if(is_callable("array_diff_key")) {
                        $j = array_diff_key($r,$this->field_hide);
                    } else {
                        $j = PHP4_array_diff_key($r,$this->field_hide);
                    }
                    $class = $cont%2?'even':'odd';
                    echo $this->table_row($j,$class,$r[$this->pk],$r,$cont);
                    $cont++;
                }

            } else {
                echo "<tr><td colspan='$colspan'><div style='text-align:center; font-weight: bold;'>".trans('No records found')."</div></td></tr>";
            }
            echo "</tbody>";

            if ($this->link->num_rows($res) > 0) {
                // FOOTER
                echo "<tfoot><tr><th colspan='".$colspan."'>";
                $this->set_pagination();
                echo $this->pagination_anchors;
                echo $this->pagination_total;
                echo "</th></tr></tfoot>";
            }

            // END
            echo "</table>\n";
            echo "</div>\n";
            echo "</div>\n";
            return false;
        }

        private function add_form() {

            if (!$this->allow_add) {
                return;
            }

            $req = substr($this->set_request('dbgrid_action','addSave',false),1);
            $params = explode("&",$req);

            $this->print_javascript('add');
            $this->print_errors();

            echo "<div class='container-fluid'>\n";
            echo "<div class='row-fluid db-table-row_'>\n";
            echo "<div class='span12'>\n";
            echo "<form method='post' class='well form-horizontal' dbgrid_action='".SELF."' enctype='multipart/form-data' id='dbgrid-edit-form'>\n";

            // comienza a imprimir la tabla
            foreach($params as $v) {
                list($key,$val)=preg_split("/=/",$v);
                if(preg_match("/^dbgrid_/",$key)) {
                    echo "<input type=hidden name='$key' value='$val'>\n";
                }
            }

            echo "<fieldset>\n";
            echo "<legend>".trans('Add Record')."</legend>\n";
            echo "\n";

            foreach ($this->structure as $field => $value){
                if(isset($this->field_no_edit[$field]) && $field!=$this->pk) {
                   continue;
                }
                if ($field!=$this->pk)    {
                    if($this->structure[$field]['foreigntable']=='') {
                        $this->create_body_form($field,$this->structure[$field]['default'],"add");
                    }
                }
            }

            if(count($this->foreign)>0) {
                foreach ($this->foreign as $ftable=>$datis) {
                    $campos = $datis['fields'];
                    if($campos<>"") {
                        if($datis['union']=="") {
                            echo "</fieldset>\n<fieldset id='foreignFieldset_$ftable' >\n<legend>".$datis['name']."</legend>\n";
                            // Tengo configurado campos en add_join_table, es para editar/agregar en formularios
                            echo "<div id='foreignAdd_$ftable'></div>";

                            echo "<div id='foreignNextBlock_$ftable' style='display:none;'>";
                            foreach(explode(",",$campos) as $xfield) {
                                $this->create_body_form($xfield,'',"edit",'x');
                            }
                            echo "</div>";

                            echo "<div class='form-actions pull-right'>";
                            echo "<input type='button' class='btn' onclick='cloneForeignBlock(\"$ftable\")' value='".trans('Add')."'>";
                            echo "</div>";
                        } else {
                            // $sechash = md5($this->salt.$mipk);
                            echo "</fieldset>\n<fieldset id='foreignFieldset_$ftable' >\n<legend>".$datis['name']."</legend>\n";
                            echo "<div id='foreign_row_${ftable}'>";
                            $this->create_body_form($datis['fields'],'',"edit","x_union");

                            echo "</div>";

                        }
                    }
                }
            }
            echo "</fieldset>\n";

            $req = $this->set_request('dbgrid_action','list',true);
            $req = $this->del_request($this->pk);

            $id=session_id();
            echo "<div class='form-actions'>\n";
            echo "<input type=hidden name='dbgrid_pkhash' value='".md5($this->salt.$id)."'>";
            echo "<input type='submit' class='btn btn-primary' name='button_ok' value='".trans('Save')."'>\n";
            echo "<input type='submit' class='btn' name='button_cancel' value='".trans('Cancel')."' onClick='javascript:location=\"".SELF."$req\"; return false;'>\n";
            echo "</div>\n";
            echo "</form>\n</div>\n</div>\n";

        }

        private function insert_row() {

            if (!$this->allow_add) {
                return;
            }

            $id = session_id();
            if(md5($this->salt.$id) <> $_POST['dbgrid_pkhash']) {
                header("HTTP/1.1 401 Unauthorized");
                die();
            }

            $status      = "OK";
            $random      = "DBGRID-".rand();
            $callbacks   = !empty($this->insert_callbacks);
            $add_fields  = array();
            $name_temp   = array();
            $query_parts = array();
            $queryval    = array();
            $foreign_fields = $foreign_fields_union = array();

            foreach ($this->structure as $field => $value) {

                if (array_key_exists($field,$_POST)) {

                    // Procesa validacion
                    if (!empty($this->validation_type[$field])) {
                        $this->check_validation_type($field,$_POST[$field]);
                    }

                    // Procesa callback de validacion
                    if (!empty($this->validation_callbacks[$field])) {
                        foreach ($this->validation_callbacks[$field] as $c) {
                            $_POST[$field] = call_user_func($c, $this, $_POST[$field], $_POST);
                        }
                    }

                    if ($field!=$this->pk){
                        $add_fields[$field]=$_POST[$field];
                    }

                }

                if (array_key_exists($field,$_FILES)) {
                    if ($field!=$this->pk) {
                        $add_fields[$field]=$_FILES[$field];
                    }
                }

            }

            // ME fijo si los campos son inserciones de tablas foreign
            foreach ($_POST as $field => $value) {
                if(preg_match("/x_insert_/",$field)) {
                    $partes = preg_split("/_x_insert_/",$field);
                    list ($tabla, $campo) = preg_split("/_/",$partes[0]);

                    // Validaciones de campo foreign tabla.campo
                    $ffield = $tabla.".".$campo;
                    if (!empty($this->validation_type[$ffield])) {
                        $this->check_validation_type($field,$_POST[$field]);
                    }

                    if (!empty($this->validation_callbacks[$ffield])) {
                        foreach ($this->validation_callbacks[$ffield] as $c) {
                            $_POST[$field] = call_user_func($c, $this, $_POST[$field], $_POST);
                        }
                    }
                    $foreign_fields[$tabla][$campo]=$_POST[$field];

                } else if ( preg_match("/x_union/",$field) ) {

                    $fieldm = preg_replace("/_x_union/","",$field);
                    list ($tabla,$campo) = preg_split("/_/",$fieldm,2);
                    if(isset($this->foreign[$tabla])) {
                       $newtabla = $this->foreign[$tabla]['union'];
                       $foreign_fields_union[$newtabla]=$_POST[$field];
                    }

/*
        [qagent] => Array
        (
            [foreignfield] => qagent.agent_id
            [mainpk] => users.id
            [name] => Agentes
            [fields] => qagent.agent
            [union] => userqagent
            [pk] => agent_id
        )
*/

                }
            }

            /*
            echo "<pre>";
            print_r($_POST);
            print_r($add_fields);
            print_r($foreign_fields);
            echo "</pre>";
            */

            if ( sizeof($add_fields) >0 ) {

                $query = "INSERT INTO $this->table SET ";

                foreach ($add_fields as $field => $value) {

                    if ( $this->structure[$field]['input']=="img" ) {
                        if( $_FILES[$field]['name']<>"" ) {
                            $name_temp[]=array('field'=>$field,'temp_name'=>$random."-".$value['name'],'name_file'=>$value['name']);
                            $this->upload_img($random,$_FILES[$field],$field);
                        }
                        $value="";
                        if( count($this->error) > 0 ) {
                            break;
                        }

                    } else if ( $this->structure[$field]['input'] == 'bitmask' ) {
                        $totbit=0;
                        foreach($value as $indv) {
                            $totbit+=$indv;
                        }
                        $value=$totbit;
                    } else if( $this->structure[$field]['input'] == 'multiselect' ) {
                        $finvalue = implode(",",$value);
                        $value    = $finvalue;
                    }

                    $query_parts[] = "%s='%s'";
                    $queryval[]    = $field;
                    $queryval[]    = $value;

                    $this->del_request($field);

                }

            }

            $query .= implode( ",", $query_parts );

            if(count($this->error)>0) {
                $this->add_form();
                return;
            }
            $res  = $this->link->consulta($query,$queryval);

            if($res) {

                $this->set_request('dbgrid_notice',trans('Record inserted'),true);

                $insert_id = $this->link->insert_id();

                // Manipulamos nombre de archivo en base
                if (sizeof($name_temp)>0) {
                    foreach ($name_temp as $key => $value) {
                        //print "nametemp $key = $value<br>";
                        if (rename($this->user_directory.$value['temp_name'], $this->user_directory.$insert_id."-".$value['name_file'])) {
                            $this->set_request('dbgrid_notice',trans('File was uploaded successfully'),true);
                            $temp_field=$value['field'];
                            $temp_name_file=$insert_id."-".$value['name_file'];
                            $query="UPDATE $this->table SET $temp_field = '$temp_name_file' WHERE $this->pk = '$insert_id'";
                            $this->link->consulta($query);
                        } else {
                            $this->set_request('dbgrid_error',trans('Problems with the file upload. Check permissions on the upload directory.'),true);
                            echo trans("fallo rename %s", $this->user_directory.$value['temp_name'])."<br>";
                        }
                    }
                }

               foreach($foreign_fields as $uptable => $ffields) {
                    if(count($ffields)>0) {
                        $query = "INSERT INTO %s SET ";
                        $query_parts = array();
                        $queryval    = array();
                        $queryval[]  = $uptable;
                        foreach ($ffields as $field => $value){
                            $query_parts[]= "%s='%s'";
                            $queryval[]=$field;
                            $queryval[]=$value;
                        }
                        // Insertamos foreign key
                        $query_parts[] = "%s='%s'";
                        $queryval[]    = $this->foreign[$uptable]['foreignfield'];
                        $queryval[]    = $insert_id;
                        $query.= implode( ",", $query_parts );
                        $this->link->consulta( $query, $queryval );
                    }
                }

               foreach($foreign_fields_union as $uniontable => $valores) {
                   foreach($valores as $valor) {
                       $qq = sprintf("INSERT INTO $uniontable VALUES ('%s','%s')",$insert_id,$valor);
                       $this->link->consulta("INSERT INTO $uniontable VALUES ('%s','%s')",$insert_id,$valor);
                   }
               }

               if($callbacks) {
                    $add_fields[$this->pk]=$insert_id;
                    foreach ($this->insert_callbacks as $c) {
                        call_user_func( $c, $add_fields );
                    }
                }

            } else {
                $this->set_request('dbgrid_error',trans('Error inserting record:<br/>').$this->link->error(),true);
                // borrar archivo subido
            }

            $this->del_request("button_ok");
            $req=$this->set_request('dbgrid_action','list',true);

            header("Location: ".SELF."$req");
        }

        private function print_javascript($accion='') {

        $sugerencias = Array();
        foreach($this->structure as $field => $datarray) {
            if(isset($this->structure[$field]['autocomplete'])) {
                $sugerencias[$field] = implode("','",$this->structure[$field]['autocomplete']);
                $sugerencias[$field] = "'".$sugerencias[$field]."'";
            }
        }

        $req=$this->set_request('dbgrid_action','delete_marked',true);
        $req=$this->set_request('dbgrid_pkhash',md5($this->salt.'marked'),false);

         echo "

<script>

\$(document).ready(function() {

    \$(\"#maintable_".$this->table."\").colResizable();

    \$(\".chz\").chosen({allow_single_deselect: true});

    \$('body').tooltip({
      selector: \"[rel=tooltip]\"
    });

    setjconf();

    \$('#dbgrid_search').keyup(function() {
         if (\$.trim($('#dbgrid_search').val()) == '') {
             \$('#dbgrid_search_x').fadeOut();
         } else {
             \$('#dbgrid_search_x').fadeIn();
         }
     });

     $('#dbgrid_search_x').click(function() {
         \$('#dbgrid_search').val('');
         \$(this).hide();
     });

     if (\$.trim($('#dbgrid_search').val()) != '') {
         \$('#dbgrid_search_x').fadeIn();
     }
     
    $('#sync').click(function() {
        let self = $(this);
        self.attr('disabled', true);
        $.ajax({
            url: '/x-caracal/sync/sync.php',
            method: 'POST',
            success: (data) => {
                noty({ 
                    text: '".trans('Synchronization complete')."',
                    type: 'success',
                    timeout: 5000,
                    layout: 'topRight',
                    theme: 'bootstrapTheme', 
                    animation: { 
                        open: 'animated bounceInRight', 
                        close: 'animated bounceOutRight', 
                        easing: 'swing', 
                        speed:500
                    }
                });
                console.log(data);
 
                self.removeAttr('disabled')
            }
        });
    });

    ";

    if($accion=="edit" || $accion=="add") {

    echo "
    \$(\".dateTime\").datetimeEntry({spinnerImage: '', datetimeFormat: 'Y-O-D H:M:S'});;

    \$(\".Time\").timeEntry({spinnerImage: '', show24Hours: true, showSeconds: true});;
   
    $('#dbgrid-edit-form').validator({messageClass:'span alert alert-error pad4', lang: '$this->language', grouped: true});

    $.tools.validator.fn(
    '[type=password]',
    'Password is wrong',
    function(el, v) {
        if(el[0].id.indexOf('pwd_')==0) {
            return true;
        } else {
            var ida = el[0].id;
            var idtemp = el[0].id.split('_',2); 
            var idb = 'pwd_'+idtemp[1];
            if($('#'+ida).val() != $('#'+idb).val()) {
                return '".trans('Passwords do not match')."';
            } else {
                return true;
            }
        }
    }
    );

    ";
    foreach($sugerencias as $campo => $cadearray) {
        echo "\$('#$campo').autocompleteArray( [$cadearray ], { delay:10, minChars:1,autoFill:false,maxItemsToShow:10,matchContains:1,matchSubset:1,cacheLength:20 } );\n";

    }

    } else {
        if($this->edit_in_place) {
            echo "
            $('.edit').editInPlace({
                url       : '//' + location.host + location.pathname, 
                params    : 'dbgrid_action=eip',
                default_text : '".trans('Click to add text')."'
            });
 
            $('.edit_area').editInPlace({
                url       : '//' + location.host + location.pathname, 
                field_type: 'textarea',
                params    : 'dbgrid_action=eip',
                default_text : '".trans('Click to add text')."'
            });
            $('.edit_select').editInPlace({
                url       : '//' + location.host + location.pathname, 
                field_type: 'select',
                params    : 'dbgrid_action=eip',
                select_text: 'Select'
            });

           ";

        }

    }

    echo "

});  // end of document ready

function setjconf(elm) {
    if(elm===undefined) {

        \$('.jconf').jConf( {
            'sText': '".trans('Are you sure?')."',
            'okBtn': '".trans('Yes')."',
            'noBtn': '".trans('No')."',
            'callResult': function(data) {
                if(data.inputVal=='jconfBtnOK') {
                    if(data.oElem.attr('id')=='erasemarked') {
                        prepare_marked();
                    } else if(data.oElem.attr('id').indexOf('deleteForeign')==0) {
                         partes = data.oElem.attr('id').split('_');
                        table_to_delete = partes[1];
                        id_to_delete = partes[2];
                        sechash = partes[3];
                        foreignDelete(table_to_delete,id_to_delete,sechash);
                    } else {
                        window.location=data.oElem.attr('id'); 
                    }
                }   
            }
        });

    } else {
        if(elm.attr('isjconf')===undefined) {
            elm.attr('isjconf','1');
            elm.jConf( {
                'sText': '".trans('Are you sure?')."',
                'okBtn': '".trans('Yes')."',
                'noBtn': '".trans('No')."',
                'callResult': function(data){
                    if(data.inputVal=='jconfBtnOK') {
                        if(data.oElem.attr('id')=='erasemarked') {
                            prepare_marked();
                        } else if(data.oElem.attr('id').indexOf('deleteForeign')==0) {
                            partes = data.oElem.attr('id').split('_');
                            table_to_delete = partes[1];
                            id_to_delete = partes[2];
                            sechash = partes[3];
                            foreignDelete(table_to_delete,id_to_delete,sechash);
                        } else {
                            window.location=data.oElem.attr('id'); 
                        }
                    }   
                }
            });
        }
    }
}

function cloneForeignBlock(table) {
    var clone = $('#foreignNextBlock_'+table).clone('deepWithDataAndEvents').removeAttr('id').appendTo('#foreignAdd_'+table).show();
    var cont=0;
    $('#foreignAdd_'+table).find(':input').each(function() {
        if($(this).attr('name')!==undefined) {
            var original_name = $(this).attr('name');
            if(original_name.indexOf('_insert_')>1) {
                cont++;
            }
        }
    });
    clone.find(':input').each(function() { 
        var original_name = $(this).attr('name');
        $(this).attr('name',original_name+'_insert_'+cont);
    });
    clone.find('select').each(function() { $(this).chosen({allow_single_deselect: true}); });
}

function foreignDelete(table,id,sechash) {
    page = window.location.pathname.substring(window.location.pathname.lastIndexOf('/')+1);
    $.ajax({
        url: page,
        type: 'POST',
        data: 'dbgrid_action=foreignDelete&foreignId='+id+'&foreignTable='+table+'&dbgrid_pkhash='+sechash,
        statusCode: {
            404: function() {
                alert('error');
            },
            200: function() {
                $('#foreign_row_'+table+'_'+id).remove();
                $('#foreign_row_delete_'+table+'_'+id).remove();
            }
        }
    });
};

function prepare_marked() {
    var inputs = document.getElementsByTagName('input');
    var totnumero='';
    for (var i=0; i < inputs.length; i++) {
        if(inputs[i].id.indexOf('dbgrid_checkbox')==0) {
            if(inputs[i].checked) {
                var minumero = inputs[i].id.substring(16);
                totnumero+=minumero+',';
            }
        }
    }
    if(totnumero.length>0) {
        totnumero = totnumero.substring(0,totnumero.length-1);
        if($('#dbgrid_selectAll').val()==1) {
            location = '".SELF.$req."&dbgrid_delete_id=wholeSelection';
        } else {
            location = '".SELF.$req."&dbgrid_delete_id='+totnumero;
        }
    }
}

function markCheckBox(n,state) {
  cont=0;
  n.find('input[type=checkbox]').each(function(index) {
      if($(this).attr('id').indexOf('dbgrid_checkbox')==0) {
          $(this).attr('checked',state);
          cont++;
      }
  });
  return cont;
}

function clearCheckAll(elm) {
   if($(elm).attr('checked')===undefined) {
       $('#markAllWarning').fadeOut(); 
       $('#checkall').attr('checked',false);
       $('#dbgrid_selectAll').val(0);
       $('#erasemarked').attr('disabled','disabled');
       $('#erasemarked').unbind('click');
   }

   var enableCheck=0;
   $('#maintable_".$this->table."').find('input[type=checkbox]').each(function(index) {
      if($(this).attr('id').indexOf('dbgrid_checkbox')==0) {
          if($(this).attr('checked')) {
              enableCheck++;
          }
      }
   });
   if(enableCheck>0) {
       $('#erasemarked').removeAttr('disabled');
       setjconf($('#erasemarked'));
   } else {
       $('#erasemarked').attr('disabled','disabled');
       $('#erasemarked').unbind('click');
   }

}

function checkAll(elm,table) {

    field = $('#'+table);

    if(elm.checked) {
       state=true;
       $('#erasemarked').removeAttr('disabled');
       setjconf($('#erasemarked'));
    } else {
       state=false;
       $('#markAllWarning').html('').fadeOut(); 
       $('#dbgrid_selectAll').val(0);
       $('#erasemarked').attr('disabled','disabled');
       $('#erasemarked').unbind('click');
    }

    var countChecked = markCheckBox(field,state);
    var num = parseInt($('#numrows_".$this->table."').html(),10);

    if(num > countChecked) {
        // Hay mas registros que marcados, ofrecemos
        if(state===true) {
            var mensaje='<div class=\'alert\' style=\'text-align:center;\'><span id=\'dbgridmsg1\'>All '+countChecked+' records on this page are selected.</span> <a href=\'#\' onclick=\"setSelectAll(1,\''+table+'\'); event.returnValue=false; return false;\"><span id=\'dbgridmsg2\'>Select all '+num+' records.</a></div>';
            $('#markAllWarning').html(mensaje).hide(); 
            $('#dbgridmsg1').load('lib/translate.php','string=All %s records on this page are selected.&var1='+countChecked);
            $('#dbgridmsg2').load('lib/translate.php','string=Select all %s records.&var1='+num);
            $('#markAllWarning').fadeIn(); 
        } 
    } 
}

function setSelectAll(value,table) {
   field = $('#'+table);
   $('#dbgrid_selectAll').val(value);
   var num = parseInt($('#numrows_".$this->table."').html(),10);
   if(value==1) {
       var mensaje='<div class=\'alert\' style=\'text-align:center;\'><span id=\'dbgridmsg3\'>All '+num+' records are selected.</span> <a href=\'#\' onclick=\"setSelectAll(0,\''+table+'\'); event.returnValue=false; return false;\"><span id=\'dbgridmsg4\'>Clear Selection</span></a></div>';
       $('#markAllWarning').html(mensaje);
       $('#dbgridmsg3').load('lib/translate.php','string=All %s records are selected.&var1='+num);
       $('#dbgridmsg4').load('lib/translate.php','string=Clear Selection');
       $('#markAllWarning').fadeIn(); 
   } else {
       $('#markAllWarning').fadeOut(); 
       markCheckBox(field,false);
       $('#checkall').attr('checked',false);
       $('#dbgrid_selectAll').val(0);
       $('#erasemarked').attr('disabled','disabled');
       $('#erasemarked').unbind('click');
   }
}

function hidediv(id) {
    $('#'+id).fadeOut('slow')
}

";

         echo "</script>\n";
    }
    private function print_errors() {

        global $jsnotifications;

        if($jsnotifications==1) {

            echo "<script type='text/javascript'>\n";

            if (count($this->error)>0) {
                foreach($this->error as $error) {
                    $error = addslashes($error);
                    echo "noty({
                       title: '".trans('An error has occurred')."',
                       type: 'error',
                       timeout: 5000,
                       layout: 'topRight',
theme: 'bootstrapTheme', animation: { open: 'animated bounceInRight', close: 'animated bounceOutRight', easing: 'swing', speed:500},
                       text: '".$error."' });";
                }
            }
            if (count($this->notice)>0) {
                foreach($this->notice as $notice) {
                $notice = addslashes($notice);
                echo "noty({
                   title: '".trans('Success!')."',
                   type: 'success',
                   timeout: 5000,
                   layout: 'topRight',
theme: 'bootstrapTheme', animation: { open: 'animated bounceInRight', close: 'animated bounceOutRight', easing: 'swing', speed:500},
                   text: '".$notice."' });";
                }
            }
            echo "</script>\n";

        } else {

            if(count($this->notice)>0) {
                echo "<div class='alert alert-success''>\n";
                echo "  <a class='close' data-dismiss='alert'>x</a>\n";
                echo "  <strong>".trans('Success!')."</strong> \n";
                foreach($this->notice as $notice) {
                    echo "<p>$notice</p>";
                }
                echo "</div>\n";
            }

            if(count($this->error)>0) {
                echo "<div class='alert alert-error' id='errorbox'>\n";
                echo "  <a class='close' data-dismiss='alert'>x</a>\n";
                echo "  <strong>".trans('An error has occurred')."</strong> \n";

                foreach($this->error as $error) {
                    echo "  <p>$error</p>\n";
                }
                echo "</div>\n";
            }
        }
    }

    private function edit_form($id) {

        if (!$this->allow_edit) {
            return;
        }

        echo "<div class='container-fluid_'>\n";
        echo "<div class='row-fluid db-table-row_ without_padding'>\n";
        echo "<div class='span12'>\n";

        $query = "SELECT $this->fields_edit FROM $this->table WHERE $this->table.$this->pk = '$id'";

        // realiza la consulta
        $resedit = $this->link->consulta($query);

        $this->set_request('dbgrid_action','editSave',true);
        $req = substr($this->set_request($this->pk,$id,false),1);

        $numrows = $this->link->num_rows($resedit);

        $params = explode("&",$req);

        $this->print_errors();
        $this->print_javascript('edit');

        echo "<form method='post' action='".SELF."' class='well form-horizontal' enctype='multipart/form-data' id='dbgrid-edit-form'>\n";

        // comienza a imprimir la tabla
        foreach($params as $v) {
            list($key,$val)=preg_split("/=/",$v);
            if(preg_match("/^dbgrid_/",$key)) {
                echo "<input type=hidden name='$key' value='$val'>\n";
            } else {
                //echo "$key = $val<br>";
            }
            if($this->pk == $key) {
                echo "<input type=hidden name='dbgrid_pkhash' value='".md5($this->salt.$val)."'>";
                echo "<input type=hidden name='$key' value='$val'>\n";
            }
        }

        echo "<fieldset>\n";
        echo "<legend>".trans('Edit Record')."</legend>\n";

        if ($this->link->num_rows($resedit) > 0) {

            $cont=0;

            $rowresult = $this->link->fetch_assoc($resedit);

            foreach ($rowresult as $field=>$value) {
                $valor_de[$field]=$value;
            }

            foreach ($rowresult as $field=>$value) {
                if (isset($this->field_edit_condition[$field])){
                    if ($this->field_edit_condition[$field]){
                         list($condfield,$condcond,$condvalue) = preg_split("/\|/",$this->field_edit_condition[$field]);
                         if($condcond == "=") {
                             if($valor_de[$condfield]==$condvalue) {
                                 $this->field_no_edit[$field] = 0;
                             } else {
                                 $this->field_no_edit[$field] = 1;
                             }
                         } else {
                             if($valor_de[$condfield]<>$condvalue) {
                                 $this->field_no_edit[$field] = 0;
                             } else {
                                 $this->field_no_edit[$field] = 1;
                             }
                         }
                    }
                }
            }

            foreach ($rowresult as $field=>$value) {
                //Verifica los campos que estan seteados con NO editar, para no mostrarlos.
                if (!(array_key_exists($field, $this->field_no_edit) && $this->field_no_edit[$field] == 1 )) {
                    if($this->structure[$field]['foreigntable']=='') {
                        // los campos foregin los editamos mas adelante
                        $this->create_body_form($field,$value,"edit",null,'bool',$rowresult);
                    }
                }
            }

            if($this->custom_edit_form <> "") {
                echo $this->custom_edit_form;
            }

            if(count($this->foreign)>0) {

                foreach ($this->foreign as $ftable=>$datis) {

                    $campos = $datis['fields'];

                    if($campos<>"") {

                        if($datis['union']=="") {

                            // one to many, sin tabla de union

                            echo "</fieldset>\n<fieldset id='foreignFieldset_$ftable' >\n<legend>".$datis['name']."</legend>\n";
                            // Tengo configurado campos en add_join_table, es para editar/agregar en formularios
                            $ras = $this->link->consulta("SELECT %s,%s FROM %s WHERE %s='%s'",$datis['pk'],$campos,$ftable, $datis['foreignfield'], $rowresult[$this->pk]);
                            $cont=1;

                            while($row = $this->link->fetch_assoc($ras)) {
                                $cont++;
                                $mipk = array_shift($row);

                                $sechash = md5($this->salt.$mipk);
                                echo "<div class='controls pull-right' id='foreign_row_delete_${ftable}_${mipk}'><a id='deleteForeign_${ftable}_${mipk}_${sechash}' class='btn jconf' rel='tooltip' title='".trans("Delete")."'><i class='glyphicon glyphicon-trash'></i></a></div>";
                                echo "<div id='foreign_row_${ftable}_${mipk}'>";
                                foreach ($row as $field=>$value) {
                                    $this->create_body_form($ftable.".".$field,$value,"edit",$mipk);
                                }
                                echo "</div>";
                            }
                            echo "<div id='foreignAdd_$ftable'></div>";

                            echo "<div id='foreignNextBlock_$ftable' style='display:none;'>";
                            foreach(explode(",",$campos) as $field) {
                                $this->create_body_form($field,'',"edit",'x');
                            }
                            echo "</div>";

                            echo "<div class='form-actions pull-right'>";
                            echo "<input type='button' class='btn btn-primary' onclick='cloneForeignBlock(\"$ftable\")' value='".trans('Add')."'>";
                            echo "</div>";

                        } else {

                            // nicolasito
                            // many to many, con tabla de union
                            echo "</fieldset>\n<fieldset id='foreignFieldset_$ftable' >\n<legend>".trans($datis['name'])."</legend>\n";
                            // Tengo configurado campos en add_join_table, es para editar/agregar en formularios

                            //$ras = $this->link->consulta("SELECT %s,%s FROM %s INNER JOIN %s ON %s.%s_%s=%s.%s INNER JOIN %s ON %s.%s = %s.%s_%s WHERE %s.%s='%s'",$datis['pk'],$campos,$this->table,$datis['union'],$datis['union'],$this->table,$this->pk,$this->table,$this->pk,$ftable,$ftable,$datis['pk'],$datis['union'],$ftable,$datis['pk'],$this->table,$this->pk,$rowresult[$this->pk] );
                            $ras = $this->link->consulta("SELECT %s,%s FROM %s INNER JOIN %s ON %s.%s_%s=%s.%s INNER JOIN %s ON %s.%s = %s.%s_%s WHERE %s.%s='%s'",$datis['pk'],$campos,$this->table,$datis['union'],$datis['union'],$this->table,$this->pk,$this->table,$this->pk,$ftable,$ftable,$datis['pk'],$datis['union'],$ftable,$datis['pk'],$this->table,$this->pk,$rowresult[$this->pk] );
                            //$cont=1;

                            $valores=array();
                            while($row = $this->link->fetch_assoc($ras)) {
                                //$cont++;
                                $mipk = array_shift($row);
                                foreach ($row as $field=>$value) {
                                    $valores[$mipk]=$value;
                                }
                            }
                            //$sechash = md5($this->salt.$mipk);
                            echo "<div id='foreign_row_${ftable}'>";
                            $this->create_body_form($campos,implode(",",$valores),"edit","y");

                            echo "</div>";
                        }
                    }
                }
            }

            $req = $this->set_request('dbgrid_action','list',true);
            $req = $this->del_request($this->pk);
            echo "</fieldset>\n";
            echo "

<div class='form-actions'>
<input type='submit' class='btn btn-primary' name='button_ok' value='".trans('Save')."'>
<input type='submit' class='btn btn-default' name='button_cancel' value='".trans('Cancel')."' onClick='javascript:location=\"".SELF."$req\"; return false;'>
</div>
";
        //Fin de Row > 0
        }
        echo "
</form>
</div>
</div>
";
    }

    private function update_row($id) {

        $status="OK";
        $callbacks = !empty($this->update_callbacks);
        $update_fields=array();

        if(md5($this->salt.$id) <> $_POST['dbgrid_pkhash']) {
            $this->add_error(trans("Trampa con el formulario"));
        }

        //echo "<pre> nico ";
        //print_r($_POST);

        $extra_query=Array();
        $insertForeign = Array();
        $insertForeignData = Array();
        //$insertForeignData[] = $this->foreigntable;

        foreach ($this->structure as $field => $value) {

            if (!(array_key_exists($field,$this->field_no_edit))) {

                if(isset($this->structure[$field]['foreigntable'])) {

                     $uptable = $this->structure[$field]['foreigntable'];
                     $foreignpk = $this->foreign[$uptable]['pk'];
                     foreach($_POST as $mkey=>$mval) {

                         if(preg_match("/^$field/",$mkey)) {
                             $fkey_partes = preg_split("/_/",$mkey);
                             $fkey = array_pop($fkey_partes);
                             if(preg_match("/_x_insert_/",$mkey)) {
                                 $insertForeign[$uptable][$fkey][]="%s='%s'";
                                 $insertForeignData[$uptable][$fkey][]=$field;
                                 $insertForeignData[$uptable][$fkey][]=$mval;
                             } else {
                                 if($fkey!="x") {
                                     // exclude cloned div
                                     if($this->structure[$field]['union']<>'') {
                                         // $mval tiene los indices de la derecha
                                         // $id tiene el valor de la izquierda
//echo "DELETE FROM ".$this->structure[$field]['union']." WHERE ".$this->table.".".$this->pk."=$id<br>";
                                         $extra_query[] = $this->link->securize_query(array("DELETE FROM %s WHERE %s_%s='%s'",$this->structure[$field]['union'],$this->table,$this->pk,$id));

                                         foreach($mval as $newval) {
//echo "INSERT INTO ".$this->structure[$field]['union']." VALUES ('$id','$newval')<br>";
                                             $extra_query[] = $this->link->securize_query(array( "INSERT INTO %s VALUES ('%s','%s')",$this->structure[$field]['union'],$id,$newval));
                                          }

                                     } else {
                                         $extra_query[] = $this->link->securize_query(array("UPDATE %s SET %s='%s' WHERE %s='%s'",$uptable,$field,$mval,$foreignpk,$fkey));
                                     }
                                 }
                             }
                         }

                     }
                } else {

                    if (array_key_exists($field,$_POST)){

                        // Procesa validacion
                        if (!empty($this->validation_type[$field])) {
                            $this->check_validation_type($field,$_POST[$field]);
                        }

                        // Procesa callback de validacion
                        if (!empty($this->validation_callbacks[$field])) {
                            foreach ($this->validation_callbacks[$field] as $c) {
                                $_POST[$field] = call_user_func($c, $this, $_POST[$field],$_POST);
                            }
                        }
                        if ($field!=$this->pk) {
                            $update_fields[$field]=$_POST[$field];
                        }
                    }
                    if (array_key_exists($field,$_FILES)){
                        if ($field!=$this->pk) {
                            $update_fields[$field]=$_FILES[$field];
                        }
                    }
                }
            }
        }

        foreach($insertForeign as $uptable=>$insertArray) {
            if(count($insertArray)>0) {
                foreach($insertArray as $discard=>$newdata) {
                    $insertForeign[$uptable][$discard][]="%s='%s'";
                    $insertForeignData[$uptable][$discard][]=$this->foreign[$uptable]['foreignfield'];
                    $insertForeignData[$uptable][$discard][]=$id;
                    $totalarray = array_merge( array("INSERT INTO ".$uptable." SET ".implode(",",$insertForeign[$uptable][$discard])),
                                               $insertForeignData[$uptable][$discard]);
                    $extra_query[] = $this->link->securize_query($totalarray);;
                }
            }
        }

        $files_to_remove = Array();
        $files_added = Array();

        $queryfields=Array();
        $queryvars=Array();

        if (sizeof($update_fields)>0){
            $query = "UPDATE $this->table SET ";
            foreach ($update_fields as $field => $value){
                //echo "nico $field = $value<br>";
                if ($this->structure[$field]['input']=='img'){
                    $this->upload_img($id,$_FILES[$field],$field);
                    if(count($this->error)>0) { break; }
                    $value=$this->name_upload;
                    $files_added[] = $value;
                    if($this->old_name_upload <> '' && $this->old_name_upload<>$value ) {
                        $files_to_remove[] = $this->old_name_upload;
                    }
                } else if($this->structure[$field]['input']=='bitmask') {
                     $totbit=0;
                     foreach($value as $indv) {
                        $totbit+=$indv;
                     }
                     $value=$totbit;
                }
                else if($this->structure[$field]['input']=='multiselect') {
                     $finvalue = implode(",",$value);
                     $value    = $finvalue;
                }
                $queryfields[]="%s='%s'";
                $queryvars[]=$field;
                $queryvars[]=$value;
                $this->del_request($field);
            }
            $query.=implode(",",$queryfields);
            $query.= " WHERE $this->pk = '%s' LIMIT 1";
            $queryvars[] = $id;
        }

        if(count($this->error)>0) {
            $this->edit_form( $id );
            return;
        }

        foreach($extra_query as $qq) {
            $res  = $this->link->consulta($qq);
        }

        $res  = $this->link->consulta($query,$queryvars);

        if($res) {
           $this->add_notice(trans('Record updated'));
            if($callbacks) {
                $update_fields[$this->pk]=$id;
                foreach ($this->update_callbacks as $c) {
                    call_user_func($c, $update_fields);
                }
           }
           $this->unlink_files($files_to_remove);
        } else {
           // $this->set_request('dbgrid_error','Error al modificar registro',true);
           $this->add_error(trans('Error updating record'));
           $this->unlink_files($files_added);
        }

        $this->del_request($this->pk);
        $this->del_request('button_ok');
        $req=$this->set_request('dbgrid_action','list',true);
        //header("Location: ".SELF."$req");

//echo"<pre>";
//print_r($extra_query);

        $this->print_grid();
    }

    private function show_form($id){

        if (!$this->allow_view) {
            return;
        }

        $this->print_javascript('show');

        $joinstring="";
        if(count($this->joins)>0) {
            foreach($this->joins as $idx=>$jointable) {
               $joinstring .= $jointable." ";
            }
        }

        $resview = $this->link->consulta("SELECT $this->fields FROM %s %s WHERE %s = '%s' %s",$this->table,$joinstring,$this->table.".".$this->pk,$id, $this->groupby);

        $primer_foreign=0;

        echo "<div class='container-fluid'>\n";
        echo "<div class='row-fluid db-table-row_'>\n";
        echo "<div class='span12'>\n";
        echo "<form class='form-horizontal'><fieldset>\n";
        echo "<legend>".trans('View Record')."</legend>\n";

        if ($this->link->num_rows($resview) > 0) {

            $row = $this->link->fetch_assoc($resview);
            foreach ($row as $field=>$value) {
                if( !array_key_exists($field, $this->field_no_edit)) {
                    if(isset($this->structure[$field])) {
                        if($this->structure[$field]['foreigntable']=='') {
                            $this->create_body_form($field,$value,"show");
                        }
                    }
                }
            }

            if(count($this->foreign)>0) {

                foreach ($this->foreign as $ftable=>$datis) {

                    $campos = $datis['fields'];
                    if($campos<>"") {
                        echo "</fieldset>\n<fieldset id='foreignFieldset_$ftable' >\n<legend>".$datis['name']."</legend>\n";
                        // Tengo configurado campos en add_join_table, es para editar/agregar en formularios
                        $ras = $this->link->consulta("SELECT %s,%s FROM %s WHERE %s='%s'",$datis['pk'],$campos,$ftable, $datis['foreignfield'], $row[$this->pk]);
                        while($row2 = $this->link->fetch_assoc($ras)) {
                            $mipk = array_shift($row2);
                            $sechash = md5($this->salt.$mipk);
                            echo "<div id='foreign_row_${ftable}_${mipk}'>";
                            foreach ($row2 as $field=>$value) {
                                $this->create_body_form($ftable.".".$field,$value,"show",$mipk);
                            }
                            echo "</div>";
                        }

                    }

                }
            }
           echo "</fieldset>\n";

           $req = $this->set_request('dbgrid_action','list',false);
            echo "<div class='form-actions'>";
            echo "<input type='submit' class='btn' name='button_cancel' onClick='javascript:location=\"".SELF."$req\"; return false;' value='".trans('Cancel')."'></div>";
        //Fin de Row > 0
        } else { echo trans("no"); }
        echo "</form></div></div>";
    }

    // Esta funcion borra UN, VARIOS o TODOS los registros de la tabla
    // Ejecuta los callbacks, remueve archivos, etc.
    private function delete_rows($ids,$customsalt='') {

        $deletingAll=0;

        if(is_array($ids)) {
            // Se pasa uno o varios registros
            // $cuantos_a_borrar = count($ids);
            $ids = implode(',', $ids);
            $querysubselect = "";
            $querydelete = "";

        } else {
            // Tenemos que borrar todos de todos, hago la consulta con condiciones y search
            $deletingAll=1;
        }

        $querysubselect = "SELECT $this->pk FROM ".$this->table." ";
        $querydelete    = "DELETE FROM ".$this->table." ";

        if($this->condition <> "") {
            $querysubselect .= $this->condition;
            $querydelete .= $this->condition;
        }

        if($this->search <> "") {
            $query_parts=array();
            foreach ($this->field_search as $key=>$val) {
                $qstring = preg_replace("/%/","\\%%",addslashes(urldecode($this->search)));
                $query_parts[]= "$key LIKE '%%".$qstring."%%'";
            }
            if(count($query_parts) > 0) {
                $searchquery=implode(" OR ",$query_parts);
                $querysubselect .= " AND (".$searchquery.") ";
                $querydelete .= " AND (".$searchquery.") ";
            }
        }

        if($customsalt<>'') {
            $mihash = md5($this->salt.$customsalt);
        } else {
            $mihash = md5($this->salt.$ids);
        }
        $callbacks = !empty($this->delete_callbacks);
        $data = array();

        if($mihash <> $this->res_request['dbgrid_pkhash']) {
            $this->add_error(trans("Tampering detected (%s)", $ids).$mihash);
        }

        if(count($this->error)>0)  {
            $this->del_request($this->pk);
            $this->set_request("dbgrid_action","list",true);
            $this->print_grid();
            return;
        }

        // Recupera datos para pasarle al delete callback y guarda nombre de archivos
        // a borrar si hubiera que borrarlos
        $files_to_remove = Array();

        $joinstring="";
        if(count($this->joins)>0) {
            foreach($this->joins as $idx=>$jointable) {
               $joinstring .= $jointable." ";
            }
        }

        if($deletingAll==0) {
            // Selecciono uno o algunos
            $resdata = $this->link->consulta("SELECT ".$this->fields." FROM %s %s WHERE %s IN (".$ids.") %s",$this->table,$joinstring,$this->table.".".$this->pk,$this->groupby);
        } else {
            // Selecciono todos
            $resdata = $this->link->consulta($querysubselect);
        }
        $cuantos_a_borrar = $this->link->num_rows($resdata);

        while($row = $this->link->fetch_assoc($resdata)) {
            foreach($row as $field=>$val) {
                if ($this->structure[$field]['input']=="img"){
                    if(trim($val)!="") {
                        $files_to_remove[] = $val;
                    }
                }
            }
            if($callbacks) {
                foreach ($this->delete_callbacks as $c) {
                    call_user_func($c, $row);
                }
            }
        }

        if(count($this->foreign)>0) {
            foreach($this->foreign as $jointable=>$datatable) {

                if($datatable['union']<>'') {
                    $tabla_a_borrar = $datatable['union'];
                    $campo_where = $this->table."_".$this->pk;
                } else {
                    $tabla_a_borrar = $jointable;
                    $campo_where = $datatable['foreignfield'];
                }

                if($deletingAll==0) {
                    $this->link->consulta("DELETE FROM %s WHERE %s IN (".$ids.")",$tabla_a_borrar,$campo_where);
                } else {
                    $this->link->consulta("DELETE FROM %s WHERE %s IN (".$querysubselect.")",$tabla_a_borrar,$campo_where);
                }
            }
        }

        if($deletingAll==0) {
            // Borro uno o algunos
            $res = $this->link->consulta("DELETE FROM %s WHERE %s IN (".$ids.")",$this->table,$this->pk);
        } else {
            // Borro todos
            $res = $this->link->consulta($querydelete);
        }

        if($res) {

            $this->unlink_files($files_to_remove);

            if($cuantos_a_borrar==1) {
                $this->set_request('dbgrid_notice',trans('Record deleted'),true);
            } else if ($cuantos_a_borrar>1) {
                $this->set_request('dbgrid_notice',trans('%s records deleted',$cuantos_a_borrar),true);
            }

        } else {
            $this->set_request('dbgrid_error',trans('Could not delete records'),true);
        }

        $this->del_request($this->pk);
        $this->del_request("button_ok");
        $req = $this->set_request('dbgrid_action','list',true);

        header("Location: ".SELF."$req");

    }

    private function create_body_form($field,$value,$type,$pkindex='',$override_field_type='',$rowresult=array()){

        switch ($type){
            case "edit":
                $atribute=(($field == $this->pk && !$this->modify_pk) || ( array_key_exists($field, $this->field_no_edit) && $this->field_no_edit[$field] == 1 )) ? "disabled='disabled'": '';
                if ($field === 'name' || $field === 'login') {
                    $atribute = "readonly";
                }
                break;
            case "show":
                $atribute="disabled='disabled'";
                break;
            case "add":
                $atribute=($field == $this->pk && !$this->modify_pk) ? "disabled='disabled'": '';
                break;
            default:
                $atribute="disabled='disabled'";
                break;
        }

        $atrbs = Array();

        if($atribute!="") {
           $atrbs[]=$atribute;
        }

        $override_type='';
        $cond_values = array();
        foreach($this->edit_type_on_condition as $cond=>$fieldtype) {
            list ($fieldcondition,$fieldcompare,$fieldvalue) = array_merge(explode("|",$cond,3),array(true));
            list ($destfield,$destfieldtype,$destfieldvalues) = array_merge(explode("|",$fieldtype), array(true));
            $fieldcompare=trim($fieldcompare);
            $fieldcondition=trim($fieldcondition);
            $do_set_input=0;
            if(isset($rowresult[$fieldcondition])) {
                if($fieldcompare=='=' || $fieldcompare=='==') {
                   if($rowresult[$fieldcondition] == $fieldvalue) {
                       $do_set_input=1;
                   }
                } else if($fieldcompare==">") {
                   if($rowresult[$fieldcondition] > $fieldvalue) {
                       $do_set_input=1;
                   }
                } else if($fieldcompare==">=") {
                   if($rowresult[$fieldcondition] >= $fieldvalue) {
                       $do_set_input=1;
                   }
                } else if($fieldcompare=="<=") {
                   if($rowresult[$fieldcondition] <= $fieldvalue) {
                       $do_set_input=1;
                   }
                } else if($fieldcompare=="<") {
                   if($rowresult[$fieldcondition] > $fieldvalue) {
                       $do_set_input=1;
                   }
                } else if($fieldcompare=="<>" || $fieldcompare=="!=") {
                   if($rowresult[$fieldcondition] != $fieldvalue) {
                       $do_set_input=1;
                   }
                } else {
                    $do_set_input=0;
                }
            }

            if($do_set_input==1) {
                if($destfield==$field) {
                    $override_type = $destfieldtype;
                    if($destfieldvalues<>"") {
                       $cond_values = preg_split("/,/",$destfieldvalues);
                    }
                    break;
                }
            }
        }

        $required="";
        if (isset($this->validation_type[$field])) {
            if(in_array('required',$this->validation_type[$field])) {
                $required="<a rel='tooltip' style='color:red;' title='".trans('Required field')."'>*</a>";
                $atrbs[]="required='required'";
            }
        }
        if (isset($this->structure[$field]['autocomplete'])) {
            //$atrbs[]="id='autocomplete_".$field."' autocomplete='off' ";
            $atrbs[]="id='".$field."' autocomplete='off' ";
            $style = isset($this->structure[$field]['style'])?$this->structure[$field]['style']:'';
            $style .= " ac_input";
            $this->structure[$field]['style']=$style;
        }
        $atributes = implode(" ",$atrbs);

        $cadavalor=Array();

        if(!is_array($value)) {
            $cadavalor[]= $this->clean_entities($value);
        } else {
            $newval = array();
            foreach($value as $idk=>$idv) {
                $newval[$idk]=$this->clean_entities($idv);
            }
            array_push($newval,$cadavalor);
        }

        if(array_key_exists($field,$this->field_name)) {
            $display_name = $this->field_name[$field];
        }else{
            $display_name = $field;
        }

        $cont=1;

        foreach ($cadavalor as $value) {
        if($cont>1) {
           $fieldp = $field.$cont;
           $display_name_p = $display_name." ".$cont;
        } else {
           $fieldp = $field;
           $display_name_p = $display_name;
        }

        if($pkindex!="") {
            $fieldp = $field."_$pkindex";
        }

        $chzclass=" class=\"chz form-control chz400\" ";
        if($pkindex=="x") {
            $pkindex=0;
            $chzclass="";
        }

        if ($this->structure[$field]['input'] != 'hidden' ) {
            $parentstyle = isset($this->structure[$field]['parentstyle'])?$this->structure[$field]['parentstyle']:'';
            printf("\n<div class='form-group %s'>",$parentstyle);
        }

        if ($this->structure[$field]['input'] != 'hidden' && $this->structure[$field]['input'] != 'img'){
            printf("<label for='%s' style='float: left; margin: 10px; width: 150px; text-align: right;'>%s %s</label>",$fieldp,$display_name_p,$required);
        }

        $style = isset($this->structure[$field]['style'])?$this->structure[$field]['style']:'';
        //$help  = isset($this->structure[$field]['instructions'])?"<p class='help-block'>".$this->structure[$field]['instructions']."</p>":'';
        if(isset($this->structure[$field]['instructions'])) {
           if(is_callable($this->structure[$field]['instructions'])) {
               $help = call_user_func($this->structure[$field]['instructions'],$field, $value);
           } else {
               $help = "<p class='help-block'>".$this->structure[$field]['instructions']."</p>";
           }
        }

        // print_r($this->structure[$field]);
        // nico
        $checktype = $this->structure[$field]['input'];
        if($override_type<>'') {
            $checktype = $override_type;
        }

        if(!isset($help)) { $help=''; }

        switch ($checktype){
            case 'textarea':
                printf('<div class="controls"><textarea %s name="%s" class="input-xlarge form-control chz400" style="height:150px;" %s>%s</textarea>%s</div>',$style,$fieldp,$atributes,$value,$help);
                break;
            case 'multiselect':
                printf('<div class="controls"><select data-placeholder="%s" %s name="%s[]" %s size="7" class="chz form-control chz400" multiple>',trans("Select some options"),$style,$fieldp,$atributes);
                $coco = preg_split("/,/",html_entity_decode($value));
                foreach ($this->structure[$field]['values'] as $k => $v) {
                    $ceca = html_entity_decode($v);
                    $caca = $k;
                    $vprint = $this->get_edit_filtered($field,$v);
                    if(in_array($ceca,$coco)) { $sel='selected'; } else { $sel=''; }
                    printf('<option value="%s" %s>%s</option>',$k,$sel,$vprint);
                }
                foreach ($cond_values as $v) {
                    $k = $v;
                    $ceca = html_entity_decode($v);
                    $caca = $k;
                    $vprint = $this->get_edit_filtered($field,$v);
                    if(in_array($caca,$coco) || in_array($ceca,$coco)) { $sel='selected'; } else { $sel=''; }
                    printf('<option value="%s" %s>%s</option>',$k,$sel,$vprint);
                }
                echo "</select>$help</div>";
                break;
            case 'select':
                printf('<div class="controls"><select data-placeholder="%s" %s name="%s" id="%s" %s %s>',trans("Select an option"),$style,$fieldp,$fieldp,$chzclass,$atributes);
                if(!is_array($this->structure[$field]['values'])) {
                    $this->structure[$field]['values'] = Array();
                }
                foreach ($this->structure[$field]['values'] as $k => $v) {
                    $vprint = $this->get_edit_filtered($field,$v);
                    printf('<option value="%s" %s>%s</option>',$k,(string)$k === $value ? 'selected' : '',$vprint);
                }
                foreach ($cond_values as $v) {
                    $k=$v;
                    $vprint = $this->get_edit_filtered($field,$v);
                    printf('<option value="%s" %s>%s</option>',$k,(string)$k === $value ? 'selected' : '',$vprint);
                }
                echo "</select>$help</div>";
                break;
            case 'bitmask':
                printf('<div class="controls"><select data-placeholder="%s" class="chz form-control chz400" name="%s[]" %s  size="7" multiple>',trans("Select some options"),$fieldp,$atributes);
                foreach ($this->structure[$field]['values'] as $k => $v) {
                    printf("<option value=\"%s\" %s>%s</option>\n",$k,$k & $value ? 'selected' : '',$v);
                }
                echo "</select>$help</div>";
                break;
            case 'datetime':
                $vprint = $this->get_edit_filtered($field,$value);
//                printf('<div class="controls"><div class="input-append"><input type="text" name="%s" class="dateTime" value="%s" %s /><span class="add-on"><i class="glyphicon glyphicon-time"></i></span></div>%s</div>',$fieldp,$vprint,$atributes,$help);
                printf('<div class="col-sm-2"><div class="input-group"><input type="text" name="%s" class="dateTime form-control" value="%s" %s /><span class="input-group-addon"><span class="glyphicon glyphicon-time"></span></span></div>%s</div>',$fieldp,$vprint,$atribute,$help);
                break;
            case 'time':
                $vprint = $this->get_edit_filtered($field,$value);
                printf('<div class="col-sm-2"><div class="input-group"><input type="text" name="%s" class="Time form-control" value="%s" %s /><span class="input-group-addon"><span class="glyphicon glyphicon-time"></span></span></div>%s</div>',$fieldp,$vprint,$atribute,$help);
                break;
            case 'date':
                $vprint = $this->get_edit_filtered($field,$value);
                printf('<div class="controls"><div class="input-append"><input type="text" name="%s" class="datePick" data-datepicker="datepicker" value="%s" %s /><span class="add-on"><i class="glyphicon glyphicon-calendar"></i></span></div>%s</div>',$fieldp,$vprint,$atributes,$help);
                break;
             case 'password':
                 $vprint = $this->get_edit_filtered($field,$value);
                 printf('<div class="controls"><input type="password" name="%s" id="pwd_%s" class="form-control chz400" value="%s" %s />%s</div><br/>', $fieldp,$fieldp,$vprint,$atributes,$help);
                 printf("<label style='float: left; margin: 10px; width: 150px; text-align: right;' for='%s_confirm'><i>%s</i></label>",$fieldp,trans('Confirm'));
                 printf('<div class="controls"><input type="password" class="form-control chz400" name="%s_confirm" id="pwdconfirm_%s" value="%s" %s></div>', $fieldp,$fieldp,$vprint,$atributes);
                break;
             case 'hidden':
                printf('<input type="hidden" name="%s" value="%s" />',
                $fieldp,$value);
                 break;
             case 'img':
                  printf('<div class="inputfile">');
                  printf('<input type="file" onChange="document.getElementById(\'text-%s\').value=this.value;" name="%s" id="%s" %s/>',$fieldp,$fieldp,$fieldp,$atributes);
                  printf("<label for='text-%s'>%s</label>",$fieldp,$display_name_p);
                  printf('<input class="fakefile" type="text" name="text-%s" id="text-%s" %s/></div>',$fieldp,$fieldp,$atribute);
                 if ($value != ""){
                    if(is_file($this->user_directory.$value)) {
                        printf('<p><img src="%s" alt="%s" title="%s"></p>',$this->user_directory.$value,$value,$value);
                    }
                 }
                 break;
             case 'email':
                printf('<div class="controls"><input class="form-control %s" type="email" name="%s" value="%s" %s /></div>',$style,$fieldp,$value,$atributes);
                break;
             case 'url':
                printf('<div class="controls"><input class="form-control %s" type="url" name="%s" value="%s" %s /></div>',$style,$fieldp,$value,$atributes);
                break;
             case 'bool':
                if($value=="on" || $value=="1" || $value=="true" ) { $checked=' checked '; } else { $checked=''; }
                printf('<div class="controls"><input type="hidden" value="off" name="%s"><input class="form-control chz100 %s" data-toggle="toggle" class="chk" data-size="mini" type="checkbox" name="%s" %s %s /></div>',$fieldp,$style,$fieldp,$checked,$atributes);
                break;
             default:
                printf('<div class="controls"><input class="form-control chz400 %s" type="text" name="%s" id="%s" value="%s" %s /></div>',$style,$fieldp,$fieldp,$value,$atributes);
                break;
        }
        if ($this->structure[$field]['input'] != 'hidden' ) {
            echo "</div>\n";
        }
        $cont++;
        }
    }

    private function db_quote($str) {

            if (is_null($str)) {
                return 'NULL';
            }

            /**
            * Handle magic_quotes_gpc
            */
            if (ini_get('magic_quotes_gpc')) {
                $str = stripslashes($str);
            }

            return "'" . $this->link->escape_string($str) . "'";
        }

    private function unlink_files($files){
        if(is_array($files)) {
            foreach($files as $file) {
                unlink($this->user_directory.$file);
            }
        } else {
            unlink($this->user_directory.$files);
        }
    }

    private function upload_img($id,$arrFile,$field=""){
        $file = $arrFile['tmp_name'];
        if ($arrFile['size']>0 && !empty($file)) {
            if (is_uploaded_file($file)) {
                if (copy ($file, $this->user_directory.$id."-".$arrFile['name'])) {
                    $res = $this->link->consulta("SELECT %s FROM %s WHERE %s='%s' LIMIT 1",$field,$this->table,$this->pk,$id);
                    if($res) {
                        $row = $this->link->fetch_assoc($res);
                        $this->old_name_upload=$row[$field];
                    }
                    $this->name_upload=$id."-".$arrFile['name'];
                }else{
                    $this->add_error(trans("No se pudo copiar el archivo"));
                }
            }else{
                $this->add_error(trans("No se pudo subir el archivo"));
            }
        }else{
            $res=$this->link->consulta("SELECT %s FROM %s WHERE %s='%s' LIMIT 1",$field,$this->table,$this->pk,$id);
            if($res) {
               $row = $this->link->fetch_assoc($res);
               $this->name_upload=$row[$field];
            } else {
               $this->name_upload="";
            }

        }
    }

   /**
     * Verifica si un email tiene formato válido y opcionalmente verifica los registros MX del dominio tambien
     *
     * @param String $email
     * @param Boolean $test_mx Verificar los registros MX del dominio
     */
    private static function isEmail($email, $test_mx = false){
        if($email=="") { return true; }
        if(preg_match("/^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$/i", $email)) {
            if($test_mx) {
                list( , $domain) = preg_split("/@/", $email);
                return getmxrr($domain, $mxrecords);
            } else {
                return true;
            }
        } else {
            return false;
        }
    }

    /**
     * Checks for a valid internet URL
     *
     * @param string $value The value to check
     * @return boolean TRUE if the value is a valid URL, FALSE if not
     */
    private static function isURL($value) {
        if (preg_match("/^http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?$/i", $value)) {
            return true;
        } else {
            return false;
        }
    }

    private static function isAlfaNumeric($value) {
        if (preg_match("/^[A-Za-z0-9 ]+$/", $value)) {
            return true;
        } else {
            return false;
        }
    }

    public static function isAlfa($value, $allow = '') {
        if (preg_match('/^[a-zA-Z' . $allow . ']+$/', $value)) {
            return true;
        } else {
            return false;
        }
    }

    private function search_rows(){
        /*$search=$_REQUEST['dbgrid_search'];
        $query_parts=array();
        foreach ($this->field_search as $key=>$val ){
            $query_parts[]= "$key LIKE '%%$search%%'";
        }
        $this->condition=implode(" OR ",$query_parts);*/
        $this->del_request('button_ok');
        $req=$this->set_request('dbgrid_action','list',true);
        $this->print_grid();
    }


//Fin de clase
}

class parseCSV {

/*

        Class: parseCSV v0.4.3 beta
        http://code.google.com/p/parsecsv-for-php/


        Fully conforms to the specifications lined out on wikipedia:
         - http://en.wikipedia.org/wiki/Comma-separated_values

        Based on the concept of Ming Hong Ng's CsvFileParser class:
         - http://minghong.blogspot.com/2006/07/csv-parser-for-php.html



        Copyright (c) 2007 Jim Myhrberg (jim@zydev.info).

        Permission is hereby granted, free of charge, to any person obtaining a copy
        of this software and associated documentation files (the "Software"), to deal
        in the Software without restriction, including without limitation the rights
        to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
        copies of the Software, and to permit persons to whom the Software is
        furnished to do so, subject to the following conditions:

        The above copyright notice and this permission notice shall be included in
        all copies or substantial portions of the Software.

        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
        IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
        THE SOFTWARE.



        Code Examples
        ----------------
        # general usage
        $csv = new parseCSV('data.csv');
        print_r($csv->data);
        ----------------
        # tab delimited, and encoding conversion
        $csv = new parseCSV();
        $csv->encoding('UTF-16', 'UTF-8');
        $csv->delimiter = "\t";
        $csv->parse('data.tsv');
        print_r($csv->data);
        ----------------
        # auto-detect delimiter character
        $csv = new parseCSV();
        $csv->auto('data.csv');
        print_r($csv->data);
        ----------------
        # modify data in a csv file
        $csv = new parseCSV();
        $csv->sort_by = 'id';
        $csv->parse('data.csv');
        # "4" is the value of the "id" column of the CSV row
        $csv->data[4] = array('firstname' => 'John', 'lastname' => 'Doe', 'email' => 'john@doe.com');
        $csv->save();
        ----------------
        # add row/entry to end of CSV file
        #  - only recommended when you know the extact sctructure of the file
        $csv = new parseCSV();
        $csv->save('data.csv', array(array('1986', 'Home', 'Nowhere', '')), true);
        ----------------
        # convert 2D array to csv data and send headers
        # to browser to treat output as a file and download it
        $csv = new parseCSV();
        $csv->output (true, 'movies.csv', $array);
        ----------------


*/


        /**
         * Configuration
         * - set these options with $object->var_name = 'value';
         */

        # use first line/entry as field names
        var $heading = true;

        # override field names
        var $fields = array();

        # sort entries by this field
        var $sort_by = null;
        var $sort_reverse = false;

        # sort behavior passed to ksort/krsort functions
        # regular = SORT_REGULAR
        # numeric = SORT_NUMERIC
        # string  = SORT_STRING
        var $sort_type = null;

        # delimiter (comma) and enclosure (double quote)
        var $delimiter = ',';
        var $enclosure = '"';

        # basic SQL-like conditions for row matching
        var $conditions = null;

        # number of rows to ignore from beginning of data
        var $offset = null;

        # limits the number of returned rows to specified amount
        var $limit = null;

        # number of rows to analyze when attempting to auto-detect delimiter
        var $auto_depth = 15;

        # characters to ignore when attempting to auto-detect delimiter
        var $auto_non_chars = "a-zA-Z0-9\n\r";

        # preferred delimiter characters, only used when all filtering method
        # returns multiple possible delimiters (happens very rarely)
        var $auto_preferred = ",;\t.:|";

        # character encoding options
        var $convert_encoding = false;
        var $input_encoding = 'ISO-8859-1';
        var $output_encoding = 'ISO-8859-1';

        # used by unparse(), save(), and output() functions
        var $linefeed = "\r\n";

        # only used by output() function
        var $output_delimiter = ',';
        var $output_filename = 'data.csv';

        # keep raw file data in memory after successful parsing (useful for debugging)
        var $keep_file_data = false;

        /**
         * Internal variables
         */

        # current file
        var $file;

        # loaded file contents
        var $file_data;

        # error while parsing input data
        #  0 = No errors found. Everything should be fine :)
        #  1 = Hopefully correctable syntax error was found.
        #  2 = Enclosure character (double quote by default)
        #      was found in non-enclosed field. This means
        #      the file is either corrupt, or does not
        #      standard CSV formatting. Please validate
        #      the parsed data yourself.
        var $error = 0;

        # detailed error info
        var $error_info = array();

        # array of field values in data parsed
        var $titles = array();

        # two dimentional array of CSV data
        var $data = array();


        /**
         * Constructor
         * @param   input   CSV file or string
         * @return  nothing
         */
        function __construct ($input = null, $offset = null, $limit = null, $conditions = null) {
                if ( $offset !== null ) $this->offset = $offset;
                if ( $limit !== null ) $this->limit = $limit;
                if ( count($conditions) > 0 ) $this->conditions = $conditions;
                if ( !empty($input) ) $this->parse($input);
        }


        // ==============================================
        // ----- [ Main Functions ] ---------------------
        // ==============================================

        /**
         * Parse CSV file or string
         * @param   input   CSV file or string
         * @return  nothing
         */
        function parse ($input = null, $offset = null, $limit = null, $conditions = null) {
                if ( $input === null ) $input = $this->file;
                if ( !empty($input) ) {
                        if ( $offset !== null ) $this->offset = $offset;
                        if ( $limit !== null ) $this->limit = $limit;
                        if ( count($conditions) > 0 ) $this->conditions = $conditions;
                        if ( is_readable($input) ) {
                                $this->data = $this->parse_file($input);
                        } else {
                                $this->file_data = &$input;
                                $this->data = $this->parse_string();
                        }
                        if ( $this->data === false ) return false;
                }
                return true;
        }

        /**
         * Save changes, or new file and/or data
         * @param   file     file to save to
         * @param   data     2D array with data
         * @param   append   append current data to end of target CSV if exists
         * @param   fields   field names
         * @return  true or false
         */
        function save ($file = null, $data = array(), $append = false, $fields = array()) {
                if ( empty($file) ) $file = &$this->file;
                $mode = ( $append ) ? 'at' : 'wt' ;
                $is_php = ( preg_match('/\.php$/i', $file) ) ? true : false ;
                return $this->_wfile($file, $this->unparse($data, $fields, $append, $is_php), $mode);
        }

        /**
         * Generate CSV based string for output
         * @param   filename    if specified, headers and data will be output directly to browser as a downloable file
         * @param   data        2D array with data
         * @param   fields      field names
         * @param   delimiter   delimiter used to separate data
         * @return  CSV data using delimiter of choice, or default
         */
        function output ($filename = null, $data = array(), $fields = array(), $delimiter = null) {
                if ( empty($filename) ) $filename = $this->output_filename;
                if ( $delimiter === null ) $delimiter = $this->output_delimiter;
                $data = $this->unparse($data, $fields, null, null, $delimiter);
                if ( $filename !== null ) {
                        header('Content-type: application/csv');
                        header('Content-Disposition: attachment; filename="'.$filename.'"');
                        echo $data;
                }
                return $data;
        }

        /**
         * Convert character encoding
         * @param   input    input character encoding, uses default if left blank
         * @param   output   output character encoding, uses default if left blank
         * @return  nothing
         */
        function encoding ($input = null, $output = null) {
                $this->convert_encoding = true;
                if ( $input !== null ) $this->input_encoding = $input;
                if ( $output !== null ) $this->output_encoding = $output;
        }

        /**
         * Auto-Detect Delimiter: Find delimiter by analyzing a specific number of
         * rows to determine most probable delimiter character
         * @param   file           local CSV file
         * @param   parse          true/false parse file directly
         * @param   search_depth   number of rows to analyze
         * @param   preferred      preferred delimiter characters
         * @param   enclosure      enclosure character, default is double quote (").
         * @return  delimiter character
         */
        function auto ($file = null, $parse = true, $search_depth = null, $preferred = null, $enclosure = null) {

                if ( $file === null ) $file = $this->file;
                if ( empty($search_depth) ) $search_depth = $this->auto_depth;
                if ( $enclosure === null ) $enclosure = $this->enclosure;

                if ( $preferred === null ) $preferred = $this->auto_preferred;

                if ( empty($this->file_data) ) {
                        if ( $this->_check_data($file) ) {
                                $data = &$this->file_data;
                        } else return false;
                } else {
                        $data = &$this->file_data;
                }

                $chars = array();
                $strlen = strlen($data);
                $enclosed = false;
                $n = 1;
                $to_end = true;

                // walk specific depth finding posssible delimiter characters
                for ( $i=0; $i < $strlen; $i++ ) {
                        $ch = $data[$i];
                        $nch = ( isset($data[$i+1]) ) ? $data[$i+1] : false ;
                        $pch = ( isset($data[$i-1]) ) ? $data[$i-1] : false ;

                        // open and closing quotes
                        if ( $ch == $enclosure ) {
                                if ( !$enclosed || $nch != $enclosure ) {
                                        $enclosed = ( $enclosed ) ? false : true ;
                                } elseif ( $enclosed ) {
                                        $i++;
                                }

                        // end of row
                        } elseif ( ($ch == "\n" && $pch != "\r" || $ch == "\r") && !$enclosed ) {
                                if ( $n >= $search_depth ) {
                                        $strlen = 0;
                                        $to_end = false;
                                } else {
                                        $n++;
                                }

                        // count character
                        } elseif (!$enclosed) {
                                if ( !preg_match('/['.preg_quote($this->auto_non_chars, '/').']/i', $ch) ) {
                                        if ( !isset($chars[$ch][$n]) ) {
                                                $chars[$ch][$n] = 1;
                                        } else {
                                                $chars[$ch][$n]++;
                                        }
                                }
                        }
                }

                // filtering
                $depth = ( $to_end ) ? $n-1 : $n ;
                $filtered = array();
                foreach( $chars as $char => $value ) {
                        if ( $match = $this->_check_count($char, $value, $depth, $preferred) ) {
                                $filtered[$match] = $char;
                        }
                }

                // capture most probable delimiter
                ksort($filtered);
                $this->delimiter = reset($filtered);

                // parse data
                if ( $parse ) $this->data = $this->parse_string();

                return $this->delimiter;

        }


        // ==============================================
        // ----- [ Core Functions ] ---------------------
        // ==============================================

        /**
         * Read file to string and call parse_string()
         * @param   file   local CSV file
         * @return  2D array with CSV data, or false on failure
         */
        function parse_file ($file = null) {
                if ( $file === null ) $file = $this->file;
                if ( empty($this->file_data) ) $this->load_data($file);
                return ( !empty($this->file_data) ) ? $this->parse_string() : false ;
        }

        /**
         * Parse CSV strings to arrays
         * @param   data   CSV string
         * @return  2D array with CSV data, or false on failure
         */
        function parse_string ($data = null) {
                if ( empty($data) ) {
                        if ( $this->_check_data() ) {
                                $data = &$this->file_data;
                        } else return false;
                }

                $white_spaces = str_replace($this->delimiter, '', " \t\x0B\0");

                $rows = array();
                $row = array();
                $row_count = 0;
                $current = '';
                $head = ( !empty($this->fields) ) ? $this->fields : array() ;
                $col = 0;
                $enclosed = false;
                $was_enclosed = false;
                $strlen = strlen($data);

                // walk through each character
                for ( $i=0; $i < $strlen; $i++ ) {
                        $ch = $data[$i];
                        $nch = ( isset($data[$i+1]) ) ? $data[$i+1] : false ;
                        $pch = ( isset($data[$i-1]) ) ? $data[$i-1] : false ;

                        // open/close quotes, and inline quotes
                        if ( $ch == $this->enclosure ) {
                                if ( !$enclosed ) {
                                        if ( ltrim($current, $white_spaces) == '' ) {
                                                $enclosed = true;
                                                $was_enclosed = true;
                                        } else {
                                                $this->error = 2;
                                                $error_row = count($rows) + 1;
                                                $error_col = $col + 1;
                                                if ( !isset($this->error_info[$error_row.'-'.$error_col]) ) {
                                                        $this->error_info[$error_row.'-'.$error_col] = array(
                                                                'type' => 2,
                                                                'info' => trans('Syntax error found on row %s.', $error_row).trans('Non-enclosed fields can not contain double-quotes.'),
                                                                'row' => $error_row,
                                                                'field' => $error_col,
                                                                'field_name' => (!empty($head[$col])) ? $head[$col] : null,
                                                        );
                                                }
                                                $current .= $ch;
                                        }
                                } elseif ($nch == $this->enclosure) {
                                        $current .= $ch;
                                        $i++;
                                } elseif ( $nch != $this->delimiter && $nch != "\r" && $nch != "\n" ) {
                                        for ($x=($i+1); isset($data[$x]) && ltrim($data[$x], $white_spaces) == ''; $x++ ) {}
                                        if ( $data[$x] == $this->delimiter ) {
                                                $enclosed = false;
                                                $i = $x;
                                        } else {
                                                if ( $this->error < 1 ) {
                                                        $this->error = 1;
                                                }
                                                $error_row = count($rows) + 1;
                                                $error_col = $col + 1;
                                                if ( !isset($this->error_info[$error_row.'-'.$error_col]) ) {
                                                        $this->error_info[$error_row.'-'.$error_col] = array(
                                                                'type' => 1,
                                                                'info' =>
                                                                        trans('Syntax error found on row %s.',(count($rows) + 1)).' '.
                                                                        trans('A single double-quote was found within an enclosed string.').' '.
                                                                        trans('Enclosed double-quotes must be escaped with a second double-quote.'),
                                                                'row' => count($rows) + 1,
                                                                'field' => $col + 1,
                                                                'field_name' => (!empty($head[$col])) ? $head[$col] : null,
                                                        );
                                                }
                                                $current .= $ch;
                                                $enclosed = false;
                                        }
                                } else {
                                        $enclosed = false;
                                }

                        // end of field/row
                        } elseif ( ($ch == $this->delimiter || $ch == "\n" || $ch == "\r") && !$enclosed ) {
                                $key = ( !empty($head[$col]) ) ? $head[$col] : $col ;
                                $row[$key] = ( $was_enclosed ) ? $current : trim($current) ;
                                $current = '';
                                $was_enclosed = false;
                                $col++;

                                // end of row
                                if ( $ch == "\n" || $ch == "\r" ) {
                                        if ( $this->_validate_offset($row_count) && $this->_validate_row_conditions($row, $this->conditions) ) {
                                                if ( $this->heading && empty($head) ) {
                                                        $head = $row;
                                                } elseif ( empty($this->fields) || (!empty($this->fields) && (($this->heading && $row_count > 0) || !$this->heading)) ) {
                                                        if ( !empty($this->sort_by) && !empty($row[$this->sort_by]) ) {
                                                                if ( isset($rows[$row[$this->sort_by]]) ) {
                                                                        $rows[$row[$this->sort_by].'_0'] = &$rows[$row[$this->sort_by]];
                                                                        unset($rows[$row[$this->sort_by]]);
                                                                        for ( $sn=1; isset($rows[$row[$this->sort_by].'_'.$sn]); $sn++ ) {}
                                                                        $rows[$row[$this->sort_by].'_'.$sn] = $row;
                                                                } else $rows[$row[$this->sort_by]] = $row;
                                                        } else $rows[] = $row;
                                                }
                                        }
                                        $row = array();
                                        $col = 0;
                                        $row_count++;
                                        if ( $this->sort_by === null && $this->limit !== null && count($rows) == $this->limit ) {
                                                $i = $strlen;
                                        }
                                        if ( $ch == "\r" && $nch == "\n" ) $i++;
                                }

                        // append character to current field
                        } else {
                                $current .= $ch;
                        }
                }
                $this->titles = $head;
                if ( !empty($this->sort_by) ) {
                        $sort_type = SORT_REGULAR;
                        if ( $this->sort_type == 'numeric' ) {
                                $sort_type = SORT_NUMERIC;
                        } elseif ( $this->sort_type == 'string' ) {
                                $sort_type = SORT_STRING;
                        }
                        ( $this->sort_reverse ) ? krsort($rows, $sort_type) : ksort($rows, $sort_type) ;
                        if ( $this->offset !== null || $this->limit !== null ) {
                                $rows = array_slice($rows, ($this->offset === null ? 0 : $this->offset) , $this->limit, true);
                        }
                }
                if ( !$this->keep_file_data ) {
                        $this->file_data = null;
                }
                return $rows;
        }

        /**
         * Create CSV data from array
         * @param   data        2D array with data
         * @param   fields      field names
         * @param   append      if true, field names will not be output
         * @param   is_php      if a php die() call should be put on the first
         *                      line of the file, this is later ignored when read.
         * @param   delimiter   field delimiter to use
         * @return  CSV data (text string)
         */
        function unparse ( $data = array(), $fields = array(), $append = false , $is_php = false, $delimiter = null) {
                if ( !is_array($data) || empty($data) ) $data = &$this->data;
                if ( !is_array($fields) || empty($fields) ) $fields = &$this->titles;
                if ( $delimiter === null ) $delimiter = $this->delimiter;

                $string = ( $is_php ) ? "<?php header('Status: 403'); die(' '); ?>".$this->linefeed : '' ;
                $entry = array();

                // create heading
                if ( $this->heading && !$append && !empty($fields) ) {
                        foreach( $fields as $key => $value ) {
                                $entry[] = $this->_enclose_value($value);
                        }
                        $string .= implode($delimiter, $entry).$this->linefeed;
                        $entry = array();
                }

                // create data
                foreach( $data as $key => $row ) {
                        foreach( $row as $field => $value ) {
                                $entry[] = $this->_enclose_value($value);
                        }
                        $string .= implode($delimiter, $entry).$this->linefeed;
                        $entry = array();
                }

                return $string;
        }

        /**
         * Load local file or string
         * @param   input   local CSV file
         * @return  true or false
         */
        function load_data ($input = null) {
                $data = null;
                $file = null;
                if ( $input === null ) {
                        $file = $this->file;
                } elseif ( file_exists($input) ) {
                        $file = $input;
                } else {
                        $data = $input;
                }
                if ( !empty($data) || $data = $this->_rfile($file) ) {
                        if ( $this->file != $file ) $this->file = $file;
                        if ( preg_match('/\.php$/i', $file) && preg_match('/<\?.*?\?>(.*)/ims', $data, $strip) ) {
                                $data = ltrim($strip[1]);
                        }
                        if ( $this->convert_encoding ) $data = iconv($this->input_encoding, $this->output_encoding, $data);
                        if ( substr($data, -1) != "\n" ) $data .= "\n";
                        $this->file_data = &$data;
                        return true;
                }
                return false;
        }


        // ==============================================
        // ----- [ Internal Functions ] -----------------
        // ==============================================

        /**
         * Validate a row against specified conditions
         * @param   row          array with values from a row
         * @param   conditions   specified conditions that the row must match
         * @return  true of false
         */
        function _validate_row_conditions ($row = array(), $conditions = null) {
                if ( !empty($row) ) {
                        if ( !empty($conditions) ) {
                                $conditions = (strpos($conditions, ' OR ') !== false) ? explode(' OR ', $conditions) : array($conditions) ;
                                $or = '';
                                foreach( $conditions as $key => $value ) {
                                        if ( strpos($value, ' AND ') !== false ) {
                                                $value = explode(' AND ', $value);
                                                $and = '';
                                                foreach( $value as $k => $v ) {
                                                        $and .= $this->_validate_row_condition($row, $v);
                                                }
                                                $or .= (strpos($and, '0') !== false) ? '0' : '1' ;
                                        } else {
                                                $or .= $this->_validate_row_condition($row, $value);
                                        }
                                }
                                return (strpos($or, '1') !== false) ? true : false ;
                        }
                        return true;
                }
                return false;
        }

        /**
         * Validate a row against a single condition
         * @param   row          array with values from a row
         * @param   condition   specified condition that the row must match
         * @return  true of false
         */
        function _validate_row_condition ($row, $condition) {
                $operators = array(
                        '=', 'equals', 'is',
                        '!=', 'is not',
                        '<', 'is less than',
                        '>', 'is greater than',
                        '<=', 'is less than or equals',
                        '>=', 'is greater than or equals',
                        'contains',
                        'does not contain',
                );
                $operators_regex = array();
                foreach( $operators as $value ) {
                        $operators_regex[] = preg_quote($value, '/');
                }
                $operators_regex = implode('|', $operators_regex);
                if ( preg_match('/^(.+) ('.$operators_regex.') (.+)$/i', trim($condition), $capture) ) {
                        $field = $capture[1];
                        $op = $capture[2];
                        $value = $capture[3];
                        if ( preg_match('/^([\'\"]{1})(.*)([\'\"]{1})$/i', $value, $capture) ) {
                                if ( $capture[1] == $capture[3] ) {
                                        $value = $capture[2];
                                        $value = str_replace("\\n", "\n", $value);
                                        $value = str_replace("\\r", "\r", $value);
                                        $value = str_replace("\\t", "\t", $value);
                                        $value = stripslashes($value);
                                }
                        }
                        if ( array_key_exists($field, $row) ) {
                                if ( ($op == '=' || $op == 'equals' || $op == 'is') && $row[$field] == $value ) {
                                        return '1';
                                } elseif ( ($op == '!=' || $op == 'is not') && $row[$field] != $value ) {
                                        return '1';
                                } elseif ( ($op == '<' || $op == 'is less than' ) && $row[$field] < $value ) {
                                        return '1';
                                } elseif ( ($op == '>' || $op == 'is greater than') && $row[$field] > $value ) {
                                        return '1';
                                } elseif ( ($op == '<=' || $op == 'is less than or equals' ) && $row[$field] <= $value ) {
                                        return '1';
                                } elseif ( ($op == '>=' || $op == 'is greater than or equals') && $row[$field] >= $value ) {
                                        return '1';
                                } elseif ( $op == 'contains' && preg_match('/'.preg_quote($value, '/').'/i', $row[$field]) ) {
                                        return '1';
                                } elseif ( $op == 'does not contain' && !preg_match('/'.preg_quote($value, '/').'/i', $row[$field]) ) {
                                        return '1';
                                } else {
                                        return '0';
                                }
                        }
                }
                return '1';
        }

        /**
         * Validates if the row is within the offset or not if sorting is disabled
         * @param   current_row   the current row number being processed
         * @return  true of false
         */
        function _validate_offset ($current_row) {
                if ( $this->sort_by === null && $this->offset !== null && $current_row < $this->offset ) return false;
                return true;
        }

        /**
         * Enclose values if needed
         *  - only used by unparse()
         * @param   value   string to process
         * @return  Processed value
         */
        function _enclose_value ($value = null) {
                if ( $value !== null && $value != '' ) {
                        $delimiter = preg_quote($this->delimiter, '/');
                        $enclosure = preg_quote($this->enclosure, '/');
                        if ( preg_match("/".$delimiter."|".$enclosure."|\n|\r/i", $value) || ($value[0] == ' ' || substr($value, -1) == ' ') ) {
                                $value = str_replace($this->enclosure, $this->enclosure.$this->enclosure, $value);
                                $value = $this->enclosure.$value.$this->enclosure;
                        }
                }
                return $value;
        }

        /**
         * Check file data
         * @param   file   local filename
         * @return  true or false
         */
        function _check_data ($file = null) {
                if ( empty($this->file_data) ) {
                        if ( $file === null ) $file = $this->file;
                        return $this->load_data($file);
                }
                return true;
        }


        /**
         * Check if passed info might be delimiter
         *  - only used by find_delimiter()
         * @return  special string used for delimiter selection, or false
         */
        function _check_count ($char, $array, $depth, $preferred) {
                if ( $depth == count($array) ) {
                        $first = null;
                        $equal = null;
                        $almost = false;
                        foreach( $array as $key => $value ) {
                                if ( $first == null ) {
                                        $first = $value;
                                } elseif ( $value == $first && $equal !== false) {
                                        $equal = true;
                                } elseif ( $value == $first+1 && $equal !== false ) {
                                        $equal = true;
                                        $almost = true;
                                } else {
                                        $equal = false;
                                }
                        }
                        if ( $equal ) {
                                $match = ( $almost ) ? 2 : 1 ;
                                $pref = strpos($preferred, $char);
                                $pref = ( $pref !== false ) ? str_pad($pref, 3, '0', STR_PAD_LEFT) : '999' ;
                                return $pref.$match.'.'.(99999 - str_pad($first, 5, '0', STR_PAD_LEFT));
                        } else return false;
                }
        }

        /**
         * Read local file
         * @param   file   local filename
         * @return  Data from file, or false on failure
         */
        function _rfile ($file = null) {
                if ( is_readable($file) ) {
                        if ( !($fh = fopen($file, 'r')) ) return false;
                        $data = fread($fh, filesize($file));
                        fclose($fh);
                        return $data;
                }
                return false;
        }

        /**
         * Write to local file
         * @param   file     local filename
         * @param   string   data to write to file
         * @param   mode     fopen() mode
         * @param   lock     flock() mode
         * @return  true or false
         */
        function _wfile ($file, $string = '', $mode = 'wb', $lock = 2) {
                if ( $fp = fopen($file, $mode) ) {
                        flock($fp, $lock);
                        $re = fwrite($fp, $string);
                        $re2 = fclose($fp);
                        if ( $re != false && $re2 != false ) return true;
                }
                return false;
        }

}
